package Modules::Restore::Tables::Table_dns;

########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

BEGIN {
  use Exporter;
  @ISA = 'Exporter';
  @EXPORT = qw( &pre_restore_tab($$$$) &restore_row($$$) );
}

use DBI;
use XML::DOM;
use XML::DOM::NodeList;

use strict;
#no strict "vars";

use Modules::Restore::Map;
use Modules::Restore::Tables::Common;
use Modules::Restore::Tables::Table_admin;
use Modules::Restore::DumpConfXML;
use Modules::Restore::DumpDoc;

my $href_admin;
my $serienNumber;

sub pre_restore_tab($$$$) {

  my ($tblName,$ptrConfXML,$clean,$xmlTable)=@_;
  unless ($tblName && ref($ptrConfXML)=~/DumpConfXML/){
    print STDERR "Modules::Restore::Tables::Table_anbieter::pre_restore_tab : wrong arguments ($tblName,..)\n";
    return 1;
  }

  $href_admin = $Modules::Restore::Tables::Table_admin::ptrAdmin; 

  my $sth;

  unless (ref($href_admin)=~/HASH/){
    $sth = $main::dbh->prepare("SELECT dnstemplate, ip_pns, ip_sns FROM admin");
    $sth->execute
      or die("Error #0201: Can not restore 'anbieter' table: $DBI::errstr\n");
    $href_admin = $sth->fetchrow_hashref;
    $sth->finish;
  }

  my ($year,$mon,$mday)=(localtime)[5,4,3];
  $year+=1900;
  $mon++;

  $serienNumber=sprintf("%04d%02d%02d",$year,$mon,$mday).'01';

  return 1;
}

sub restore_row($$$) {
  my ($table_name, $ptrRow,$ptrTable) = @_;
  my ($oldRes,$key,$newRes,$sql,$sth);
  $oldRes = $ptrRow->{'anbieter'};
  $key = "reseller($oldRes).name";
  $newRes = $main::map->get_attr($key)||$oldRes;
  
  $sql="select dnsspezial,pns,sns,standardip from anbieter where anbieter='$newRes'";
  unless ($sth=$main::dbh->prepare($sql)) {
    print STDERR "Error: Table_dns: unable to execute '$sql'\n$DBI::errstr\n";
    return 1;
  }
  unless($sth->execute){
    print STDERR "Error: Table_dns: unable to exequte request: '$sql'\n$DBI::errstr\n";
    return 1;
  }
    
  unless ( $sth->rows) {
    print STDERR "Error: Table_dns: Reseller '$newRes' is not found\n";
    return 1;
  }
  my ($dnsspezial,$pns,$sns,$ip)=$sth->fetchrow;
  $sth->finish;

  my ($ip_sns,$ip_pns,$dnstemplate,$oldDomain,$newDomain,$zonafile,$newIP,
      $zonefile,$pnsdom,$snsdom);

  $ip_sns=$href_admin->{'ip_sns'};
  $ip_pns=$href_admin->{'ip_pns'};
  unless($dnstemplate=$href_admin->{'dnstemplate'}){
    print STDERR "Error: Table_dns: DNS-template is not found\n";
    return 1;
  }
  $oldDomain = $ptrRow->{'domain'};
  $key ="domain($oldDomain).name";
  $newDomain=$main::map->get_attr($key)||$oldDomain;

  ($zonefile=$dnstemplate)=~s/##domain##/$newDomain/g;
  $zonefile=~s/##ns1##/$pns/g;
  $zonefile=~s/##ns2##/$sns/g;
  if($ip=~/standard/){
    $ip=$href_admin->{'standardip'};
  }
  if($ptrRow->{'zonefile'}=~/\s(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/){
    $ip=$1;
  }
  $key="ip($ip).address";
  unless($newIP=$main::map->get_attr($key)){
    print STDERR "Error: Table_dns: New value for ip '$ip' is not found\n";
    $newIP=$href_admin->{'standardip'};
  }
  $zonefile=~s/##ip##/$newIP/g;

  ($snsdom=$sns)=~s/^[^.]+.//;
  if($snsdom eq $newDomain){
    $zonafile=$sns.".     864000  IN   A   $ip_sns\n".$zonefile;
  }
  ($pnsdom=$pns)=~s/^[^.]+.//;
  if($pnsdom eq $newDomain){
    $zonafile=$pns.".     864000  IN   A   $ip_pns\n".$zonefile;
  }
  $ptrRow->{'zonefile'}=$zonefile;
  $ptrRow->{'lastchange'}=$serienNumber;


  return 1; ## goto common part

}

1;
