<?
########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once ( dirname(__FILE__) . "/class.DefinableColumn.php" );
include_once ( dirname(__FILE__) . "/class.ServiceColumn.php" );
include_once ( dirname(__FILE__) . "/class.ResellerLimitColumn.php" );
include_once ( dirname(__FILE__) . "/class.ResellerStorageColumn.php" );
include_once ( dirname(__FILE__) . "/class.ResellerTrafficColumn.php" );
include_once ( dirname(__FILE__) . "/class.ServiceColumn.php" );
include_once ( dirname(__FILE__) . "/limits/class.AllLimits.php" );
include_once ( dirname(__FILE__) . "/class.ShellColumn.php" );
include_once ( dirname(__FILE__) . "/module.Informer.php" );
include_once ( dirname(__FILE__) . "/class.RadioGroupColumn.php" );
include_once ( dirname(__FILE__) . "/class.CompoundColumn.php" );
include_once ( dirname(__FILE__) . "/idn_functions.php" );
include_once ( dirname(__FILE__) . "/class.InputDecode.php" );
include_once ( dirname(__FILE__) . "/module.DNSTemplate.php" );
include_once ( dirname(__FILE__) . "/class.Page.php" );
include_once ( dirname(__FILE__) . "/class.Actor.php" );
include_once ( dirname(__FILE__) . "/class.SQLFieldSet.php" );



class User extends Actor {

    /* -------------------- Members -------------------- */

    var $ma_Domains; // array of domains
    var $ma_NatDomains; // array of national domains
    var $ma_DNS; // array of DNS flags
    var $ma_DNR; // array of DNR flags
    var $ma_DBDNR; // array of DNR flags from DB

    var $ms_CurrentIP; // current ip
    var $ms_Exclusive; // use ip address exclusively
    
    var $ma_Statistics;  // array of user's statistics 
    var $ma_Settings; // array of user's settings
    var $ma_Required; // array of required fields
    /* -------------------- end Members -------------------- */





    /* -------------------- Constructor -------------------- */
    function User( $ps_UserName='')
    {
    	if( $ps_UserName ){
    		$this->ms_Name=$ps_UserName;
    		if( strpos( $ps_UserName,$GLOBALS['user_prefix'] ) === 0 ){
    			$this->ms_Number=substr( $ps_UserName, strlen( $GLOBALS['user_prefix'] ) );
    		}
    	}

			$this->Actor();

    	$this->ma_Statistics = array();
    	$this->ma_Settings = array();
    	
			$this->ma_Domains = array();
			$this->ma_Required = array();
			$this->ma_NatDomains = array();
			$this->ma_DNS = array();
			$this->ma_DNR = array();
			$this->ma_DBDNR = array();
    }
    /* -------------------- end Constructor -------------------- */





    /* -------------------- personal information -------------------- */
    function InitializePersonal () {
			parent::InitializePersonal();

			$this->ma_Personal["kundennummer"] = new InputTextColumn ( "kundennummer", ltext("pi_customerid"), "" );
			$this->ma_Personal["freifeldname1"] = new DefinableColumn ( "freifeldname1", "freifeldwert1", "", "" );
			$this->ma_Personal["freifeldname2"] = new DefinableColumn ( "freifeldname2", "freifeldwert2", "", "" );
			$this->ma_Personal["freifeldname3"] = new DefinableColumn ( "freifeldname3", "freifeldwert3", "", "" );
			
			$lo_Column = new CompoundColumn ( NULL, "", "" );
			$lo_Text = new InputTextColumn ( NULL, "", ltext("kune3_cell_text1") );
			$lo_Text->SetInput (FALSE);
			$lo_Column->AddColumn ( $lo_Text );
			
			$lo_Radio = new RadioGroupColumn ( array( 1=>ltext("g_yes"), 0=>ltext("g_no") ), "kundendatenanzeigen", "", "1" );
			$lo_Radio->SetSeparator ( " " );
			$lo_Column->AddColumn ($lo_Radio);
			$lo_Column->SetSeparator ( "<br>" );
			
			$this->ma_Personal["kundendatenanzeigen"] = $lo_Column;
    }

    function ValidatePersonal ()
    {
			$ls_Result = TRUE;
			$ls_Definable = FALSE;
			foreach ( array_keys($this->ma_Personal) as $ls_Key )	{
				$lo_Column =& $this->ma_Personal[$ls_Key];
				if ( ! $lo_Column->IsValid() ) {
					if ( strtolower ( get_class($lo_Column) ) == "definablecolumn" ||
							 is_subclass_of ( $lo_Column, "definablecolumn" ) )	{
						if ( ! $ls_Definable ) {
							$this->AddMessage ( ERROR, ltext( "kune4_error1" ) );
							$ls_Definable = TRUE;
						}
					}	else
						$this->AddMessage ( ERROR, ltext ( "fp_incorrect_field", $lo_Column->GetLabel() ) );
					$ls_Result = FALSE;
				}
			}
			return $ls_Result;
    }

	function SetPersonalData( $pa_Data ){
		// set ID to the specified value (if it is new user)
		// then clean this variable
		$freifeldname3 = $pa_Data['freifeldname3'];
		$freifeldwert3 = $pa_Data['freifeldwert3'];
		if (($freifeldname3 == "add-user") && ((int)$freifeldwert3 > 0) 
		  && defined($this->ms_Number)) 
		{
			$pa_Data['freifeldname3'] = "";
			$pa_Data['freifeldwert3'] = "";

			global $user_prefix;
			if (!if_user_exists($user_prefix.$freifeldwert3)) {
				$this->ms_Number = $freifeldwert3;
			}
		}

		parent::SetPersonalData( $pa_Data );

    }


    /* -------------------- end personal information -------------------- */




    /* -------------------- services & limits -------------------- */
    function AddLimit ( $ps_Name, $ps_Value, $ps_Limit, $ps_Maximum, $ps_Hard, $ps_Reseller, $ps_Query=NULL )
    {
	if ( $ps_Limit )
	{
	    $lo_Column = new ResellerLimitColumn ( $ps_Name, ltext("uc_$ps_Name"), $ps_Value );
	    $lo_Column->CallOnValidator ( "SetLimit", $ps_Limit );
	    $lo_Column->CallOnValidator ( "SetMaximum", $ps_Maximum );
	    $lo_Column->CallOnValidator ( "SetHardLimit", $ps_Hard );
	    $lo_Column->CallOnValidator ( "SetQuery", is_null($ps_Query) ?
		    "SELECT SUM($ps_Name) FROM kunden WHERE anbieter = $ps_Reseller" : $ps_Query );
	    $this->ma_Services[$ps_Name] = $lo_Column;
	}
    }

    function AddService ( $ps_Name, $pa_ResellerData ){
			if ( $pa_ResellerData[$ps_Name] )
				$this->ma_Services[$ps_Name] = new ServiceColumn ( $ps_Name, ltext("uc_$ps_Name"), "1" );
    }

    function InitializeServices ( $pa_ResellerData ) {
			$this->ma_Services = array();

			$ls_Reseller = db_full_quote($pa_ResellerData['anbieter']);

			$lo_Column = new ResellerStorageColumn ( "maxkb", ltext("uc_maxkb"), "" );
			$lo_Column->CallOnValidator ( "SetLimit", $pa_ResellerData["maxkb"] );
			$lo_Column->CallOnValidator ( "SetHardLimit", $pa_ResellerData["maxkblimit"] );
			$lo_Column->CallOnValidator ( "SetQuery", "SELECT SUM(maxkb) FROM kunden WHERE anbieter = $ls_Reseller" );
			$this->ma_Services["maxkb"] = $lo_Column;

			$this->AddLimit ( "maxpop", "-1", $pa_ResellerData["maxpop"], 
												0x7FFF, $pa_ResellerData["maxpoplimit"],
												$ls_Reseller );
			$this->AddLimit ( "maxemail", "-1", $pa_ResellerData["maxemail"], 
												0x7FFF, $pa_ResellerData["maxemaillimit"],
												$ls_Reseller );
			$this->AddLimit ( "maxautoresponder", "-1", $pa_ResellerData["maxautoresponder"], 
												0x7FFF,
												$pa_ResellerData["maxautoresponderlimit"], $ls_Reseller );
			$this->AddLimit ( "maxftp", "0", $pa_ResellerData["maxftp"], 
												0x7FFFFF, $pa_ResellerData["maxftplimit"],
												$ls_Reseller );

			$lo_Column = new ResellerTrafficColumn ( "maxtransfer", ltext("uc_maxtransfer"), "" );
			$lo_Column->CallOnValidator ( "SetLimit", $pa_ResellerData["maxtransfer"] );
			$this->ma_Services["maxtransfer"] = $lo_Column;

			$this->AddLimit ( "maxsubdomains", "0", $pa_ResellerData["maxsubdomains"], 
												0x7FFF,
												$pa_ResellerData["maxsubdomainslimit"], $ls_Reseller );
			$this->AddLimit ( "maxmysql", "1", $pa_ResellerData["maxmysql"], 
												0x7FFF, $pa_ResellerData["maxmysqllimit"],
												$ls_Reseller );
			$this->AddLimit ( "wildcard", "0", $pa_ResellerData["maxwildcards"], 
												0x7FFF, $pa_ResellerData["maxwildcardslimit"],
												$ls_Reseller );

			$this->AddLimit ( "maxatdomains", "0", $pa_ResellerData["maxatdomains"], 
												0x7FFF,
												$pa_ResellerData["maxatdomainslimit"], $ls_Reseller );
			$this->AddLimit ( "maxcronjobs", "0", $pa_ResellerData["maxcronjobs"], 
												0x7FFF, $pa_ResellerData["maxcronjobslimit"],
												$ls_Reseller );
			$this->AddLimit ( "maxmaillist", "0", $pa_ResellerData["maxmaillist"], 
												0x7FFFFFFF,
												$pa_ResellerData["maxmaillistlimit"], $ls_Reseller );

			foreach ( array(  "ftp", "cssl", "php", "phpupload", "perl", "modpython", "ssi", 
											 "wap", "coldfusion", "frontpage" ) as $ls_Name ) {
				$this->AddService ( $ls_Name, $pa_ResellerData );
			}

			if ( $pa_ResellerData["shell"] && $pa_ResellerData["scponly"] )	{
				$this->ma_Services["shell"] = new SelectColumn
					( array( 0=>ltext("g_no"), 1=>ltext("uc_stdshell"), 2=>ltext("uc_scponly") ),
						"shell", ltext ("uc_shell"), "0" );
			}	elseif ( $pa_ResellerData["shell"] ) {
				$this->ma_Services["shell"] = new ShellColumn ( "shell", ltext ("uc_shell"), "0" );
			}	elseif ( $pa_ResellerData["scponly"] ) {
				$lo_Column = new ShellColumn ( "scponly", ltext ("uc_scponly"), "0" );
				$lo_Column->SetStandard (FALSE);
				$this->ma_Services["shell"] = $lo_Column;
			}

			foreach ( array( "dirlist", "statistik", "pwschutz", "fehlerseiten", 
											 "webftp", "webmail", "stdcgi" ) as $ls_Name ) {
				$this->AddService ( $ls_Name, $pa_ResellerData );
			}

			if ( $pa_ResellerData["maxpop"] ){
				$this->AddService ( "spamfilter", $pa_ResellerData );
			}
			if ( $pa_ResellerData["backup"] ) {
				if( $pa_ResellerData["backup"] > 1 ){
					$this->ma_Services["backup"] = new SelectColumn	( array( 
																			0=>ltext("g_no"), 
																			1=>ltext("g_yes"), 
																			2=>ltext("uc_backup_upload") 
																		),
																		"backup", 
																		ltext ("uc_backup"), 
																		1 
																	);
				} else {
					$this->AddService ( "backup", $pa_ResellerData );
				}
			}

			$lo_Limits = new AllLimits ( "UserCanHave", $pa_ResellerData );
			for ( $lo_Limits->FirstService(); $lo_Service =& $lo_Limits->NextService(); ) {
				$this->ma_Services[$lo_Service->GetName()] = new ServiceColumn ( $lo_Service->GetName(),  $lo_Service->GetLabel(), "1" );
			}

    }


    function ValidateServices() {
			$ls_Result = TRUE;
			foreach ( array_keys($this->ma_Services) as $ls_Key )	{
				$lo_Column =& $this->ma_Services[$ls_Key];
				$lo_Validator =& $lo_Column->GetValidator();
				if ( method_exists ( $lo_Validator, "SetCurrentFromSQL" ) )
					$lo_Validator->SetCurrentFromSQL();
				if ( !$lo_Column->IsValid() )	{
					switch ( method_exists( $lo_Validator, "GetError" ) ?
									 $lo_Column->CallOnValidator( "GetError" ) : NULL )
						{
						case cc_LimitErrorLimit:
							if ($lo_Column->CallOnValidator("GetLimit")-$lo_Column->CallOnValidator("GetCurrent") < 0)
								$this->AddMessage ( ERROR, ltext( "kune3_error36", $lo_Column->GetLabel(), $lo_Column->CallOnValidator("GetCurrent"), 
																									$lo_Column->CallOnValidator("GetLimit") ) );
							else
								$this->AddMessage ( ERROR, ltext( "uc_limit", $lo_Column->GetLabel(),
																									$lo_Column->CallOnValidator("GetLimit")-$lo_Column->CallOnValidator("GetCurrent") ) );
							break;
						case cc_LimitErrorMaximum:
							$this->AddMessage ( ERROR, ltext( "uc_maximume", $lo_Column->GetLabel(),
																								$lo_Column->CallOnValidator( "GetMaximum" ) ) );
							break;
						case cc_LimitErrorInvalidChar:
						default:
							$this->AddMessage ( ERROR, ltext( "uc_invalidchar", $lo_Column->GetLabel() ) );
							break;
						}
					$ls_Result = FALSE;
	    }
	}
	if ( array_key_exists("maxemail",$this->ma_Services) && array_key_exists("maxautoresponder",$this->ma_Services) )
	{
	    $lo_EMail = $this->ma_Services["maxemail"];
	    $lo_Auto = $this->ma_Services["maxautoresponder"];
	    if ( $lo_EMail->GetValue() != -1 &&
		    ( $lo_Auto->GetValue() == -1 || $lo_Auto->GetValue()>$lo_EMail->GetValue() ) )
	    {
		$this->AddMessage ( ERROR, ltext("kune3_error7") );
		$ls_Result = FALSE;
	    }
	}
	if ( array_key_exists("ftp",$this->ma_Services) && array_key_exists("maxftp",$this->ma_Services) )
	{
	    $lo_FTP = $this->ma_Services["ftp"];
	    $lo_MaxFTP = $this->ma_Services["maxftp"];
	    if ( $lo_FTP->GetValue()==0 && $lo_MaxFTP->GetValue() != 0 )
	    {
		$this->AddMessage ( ERROR, ltext("kune3_error9") );
		$ls_Result = FALSE;
	    }
	}
	if ( array_key_exists("shell",$this->ma_Services) && array_key_exists("ftp",$this->ma_Services) )
	{
	    $lo_Shell = $this->ma_Services["shell"];
	    $lo_FTP = $this->ma_Services["ftp"];
	    if ( $lo_Shell->GetValue()==1 && $lo_FTP->GetValue()==0 )
	    {
		$this->AddMessage ( ERROR, ltext("kune3_error14") );
		$ls_Result = FALSE;
	    }
	}
	if ( array_key_exists("php",$this->ma_Services) && array_key_exists("phpupload",$this->ma_Services) )
	{
	    $lo_PHP = $this->ma_Services["php"];
	    $lo_PHPUpload = $this->ma_Services["phpupload"];
	    if ( $lo_PHP->GetValue()==0 && $lo_PHPUpload->GetValue()==1 )
	    {
		$this->AddMessage ( ERROR, ltext("kund3_error26") );
		$ls_Result = FALSE;
	    }
	}
	if ( array_key_exists("maxsubdomains",$this->ma_Services) && array_key_exists("wildcard",$this->ma_Services) )
	{
	    $lo_Subdomains = $this->ma_Services["maxsubdomains"];
	    $lo_Wildcard = $this->ma_Services["wildcard"];
	    if ( $lo_Subdomains->GetValue()!=-1 && $lo_Subdomains->GetValue()<$lo_Wildcard->GetValue() )
	    {
		$this->AddMessage ( ERROR, ltext("kune3_error23") );
		$ls_Result = FALSE;
	    }
	}

       if ( array_key_exists("frontpage",$this->ma_Services) && array_key_exists("fehlerseiten",$this->ma_Services) )
        {
            $loErrorFiles = $this->ma_Services["fehlerseiten"];
            $loFrontPage = $this->ma_Services["frontpage"];
            if ($loFrontPage->GetValue()==1 && $loErrorFiles->GetValue() ==1 )
            {
                $this->AddMessage ( ERROR, ltext("anne2_error23") );
		                $ls_Result = FALSE;
	    }
	}
	
       if ( array_key_exists("frontpage",$this->ma_Services) && array_key_exists("pwschutz",$this->ma_Services) )
        {
	    $loFrontPage = $this->ma_Services["frontpage"];
	    $loPassProtect = $this->ma_Services["pwschutz"];
	    if ( $loFrontPage->GetValue()==1 && $loPassProtect->GetValue()==1 )
	    {
	        $this->AddMessage ( ERROR, ltext("anne2_error24") );
	        $ls_Result = FALSE;
	    }
	}
																			
	if ( array_key_exists("stdcgi",$this->ma_Services) && array_key_exists("perl",$this->ma_Services) )
	{
	    $lo_StdCGI = $this->ma_Services["stdcgi"];
	    $lo_Perl = $this->ma_Services["perl"];
	    if ( $lo_StdCGI->GetValue()==1 && $lo_Perl->GetValue()!=1 )
	    {
		$this->AddMessage ( ERROR, ltext("kune3_error25") );
		$ls_Result = FALSE;
	    }
	}
	return $ls_Result;
    }


    function SetServicesFromSQL ( $ps_Query )
    {
		$this->SetFromSQL ( $this->ma_Services, $ps_Query );
		$this->FixTraffic();
    }
    
    function SetServicesFromArray ( &$paServices )
    {
    	if ($paServices["scponly"]) {
    		$paServices["shell"] = 2;
    	}
		$this->SetFromArray ( $this->ma_Services, $paServices );
		$this->FixTraffic();
    }

    function FixTraffic()
    {
	if ( ( $ls_Value = $this->ma_Services["maxtransfer"]->GetValue() ) > 0 )
	    $this->ma_Services["maxtransfer"]->SetValue ( $ls_Value/1024 );
    }


    /* -------------------- end services & limits -------------------- */




    /* -------------------- domains -------------------- */
	function InitializeDomains ( $ps_Query ) {
		$this->ma_Domains = $this->ma_NatDomains = $this->ma_DNS = $this->ma_DNR = $this->ma_DBDNR = array();
		$lo_DB =& get_db_connection();
		$lo_Query =& $lo_DB->Select ( $ps_Query );
		for ( $i=1; $la_Row =& $lo_Query->nextrow(); $i++ ) {
			$this->ma_Domains[$i] = trim( $la_Row["domain"] );
			$this->ma_DNS[$i] = $this->ma_DNR[$i] = $this->ma_DBDNR[$i] = 0;
			if( array_key_exists( "dns", $la_Row ) )
				$this->ma_DNS[$i] = $la_Row["dns"];
		}
	}

    function InitializeDNS ( $ps_Query )
    {
	$this->ma_Domains = $this->ma_DNS = $this->ma_DNR = $this->ma_DBDNR = array();
	$lo_DB =& get_db_connection();
	$lo_Query =& $lo_DB->Select ( $ps_Query );
	for ( $i=1; $la_Row =& $lo_Query->nextrow(); $i++ )
	{
	    $ls_Domain = trim( $la_Row["domain"] );
	    $ls_IDN = get_html_idn_name($ls_Domain);
	    $this->ma_Domains[$i] = $ls_Domain = $ls_IDN ? $ls_IDN : $ls_Domain;
	    if ( $la_Row["neu"]==2 )
	    {
		$this->ma_DNS[$i] = $this->ma_DNR[$i] = 0;
		$this->ma_DBDNR[$ls_Domain] = $la_Row["dnr"];
	    }
	    else
	    {
		$this->ma_DNS[$i] = $la_Row["neu"]==1 ? 1 : $la_Row["dns"];
		$this->ma_DBDNR[$ls_Domain] = $this->ma_DNR[$i] = $la_Row["dnr"];
	    }
	}
    }

    function InitializeDBDNR ( $ps_Query )
    {
	$this->ma_Domains = $this->ma_DNS = $this->ma_DNR = $this->ma_DBDNR = array();
	$lo_DB =& get_db_connection();
	$lo_Query =& $lo_DB->Select ( $ps_Query );
	while ( $la_Row =& $lo_Query->nextrow() )
	{
	    $ls_Domain = trim( $la_Row["domain"] );
	    $ls_IDN = get_html_idn_name($ls_Domain);
	    if ( $ls_IDN )
		$ls_Domain = $ls_IDN;
	    $this->ma_DBDNR[ $ls_Domain ] = $la_Row["dnr"];
	}
    }

    function GetDomains() {
			return $this->ma_Domains;
    }

    function GetNatDomains() {
			return $this->ma_NatDomains;
    }
    
     function &NatDomains( $paNatDomains = NULL ) {
			if( is_array( $paNatDomains ) ) {
				$this->ma_NatDomains = array();
				foreach ( array_keys($paNatDomains) as $liID ) {
					$this->ma_NatDomains[$liID] = $paNatDomains[$liID];
				}
			}
			return $this->ma_NatDomains;
    }
    
    function &Domains( $paDomains = NULL ) {
			if( is_array( $paDomains ) ) {
				$this->ma_Domains = array();
				foreach ( array_keys($paDomains) as $liID ) {
					$this->ma_Domains[$liID] = $paDomains[$liID];
				}
			}
			return $this->ma_Domains;
    }


    function GetDNS()
    {
			return $this->ma_DNS;
    }

    function &DNS( $paDNS = NULL ) {
			if( is_array( $paDNS ) ) {
				$this->ma_DNS = array();
				foreach ( array_keys($paDNS) as $liID ) {
					$this->ma_DNS[$liID] = $paDNS[$liID];
				}
			}
			return $this->ma_DNS;
    }


    function GetDNR()
    {
			return $this->ma_DNR;
    }

    function &DNR( $paDNR = NULL ) {
			if( is_array( $paDNR ) ) {
				$this->ma_DNR = array();
				foreach ( array_keys($paDNR) as $liID ) {
					$this->ma_DNR[$liID] = $paDNR[$liID];
				}
			}
			return $this->ma_DNR;
    }


    function GetDBDNR()
    {
	return $this->ma_DBDNR;
    }

    function SetDomains ( $pa_Domains )
    {
			$this->ma_Domains = $pa_Domains;
    }

    function SetNatDomains ($pa_NatDomains) {
			$this->ma_NatDomains = $pa_NatDomains;
    }
    
    function SetDNS ( $pa_DNS )
    {
			$this->ma_DNS = $pa_DNS;
    }

    function SetDNR ( $pa_DNR )
    {
			$this->ma_DNR = $pa_DNR;
    }

		function SetDomainsData( $pa_POST ) {
			$this->SetDomains( $pa_POST['domain'] );
			$this->SetNatDomains( $pa_POST['natdomain'] );
			$this->SetDNS( $pa_POST['domdns'] );
			$this->SetDNR( $pa_POST['domdnr'] );
		}

    function ValidateDomains ( $pa_Reseller ) {
			global $user_prefix;
			$la_Domains = $this->AdjustDomains();
			if ( !count($la_Domains) )	{
				$this->AddMessage ( ERROR, ltext ( "kune5_error16" ) );
				return FALSE;
			}
			$lo_DB =& get_db_connection();
			if ( $pa_Reseller["maxdomains"] >= 0 && $pa_Reseller["maxdomainslimit"] )	{
				$lo_Query =& $lo_DB->Select ( "SELECT COUNT(*) FROM domains WHERE anbieter = " .
																			db_full_quote($pa_Reseller["anbieter"]) . " AND richtigedomain=1" );
				$la_Data =& $lo_Query->nextrow();
				if ( $la_Data[0]+count($la_Domains) > $pa_Reseller["maxdomains"] ) {
					$this->AddMessage ( ERROR, ltext ( "kune5_error17", $pa_Reseller["maxdomains"], $la_Data[0] ) );
					return FALSE;
				}
			}
			$lo_Query =& $lo_DB->Select ( "SELECT standarddomain, idn FROM admin" );
			$la_Admin =& $lo_Query->nextrow();
			$ls_IDN = $la_Admin["idn"];
			$ls_Expression = "/^${user_prefix}[0-9]+\." . str_replace( ".", "\.", $la_Admin["standarddomain"] ) . "$/i";
			$la_WrongIDN = $la_Existing = $la_Badnames = $la_Reserved = array();
#
#	IDN
#			
			foreach ( $la_Domains as $ls_Key => $ls_Domain ) {
				$ls_Translated = InputDecode::decode ($ls_Domain);
				if ( $ls_IDN && $ls_Translated != $ls_Domain )
					$la_Domains[$ls_Key] = translate_name_to_idn ( $ls_Domain );
				elseif ( !$ls_IDN && $ls_Translated != $ls_Domain )
					$la_WrongIDN[] = $ls_Domain;
				if ( ! preg_match ( "/^[^\.]+(\.[^\.]+)+$/i", $ls_Domain ) || preg_match ( "/^www\./i", $ls_Domain ) )	    {
					$la_Badnames[] = $ls_Domain;
					continue;
				}
				if ( preg_match ( $ls_Expression, $ls_Domain ) ) {
					$la_Reserved[] = $ls_Domain;
					continue;
				}
				$lo_Query =& $lo_DB->Select ( "SELECT domain FROM domains WHERE domain = " . db_full_quote($ls_Domain) );
				if ( $lo_Query->nextrow() )
					$la_Existing[] = $ls_Domain;
				
			}
			
			$ls_Result = TRUE;
			if ( count($la_Badnames) ) {
				$this->AddMessage ( ERROR, ltext ( "kune5_error19", implode ( ", ", $la_Badnames ) ) );
				$ls_Result = FALSE;
			}
			if ( count($la_WrongIDN) )	{
				$this->AddMessage ( ERROR, ltext ( "error_bad_domains__no_idn_support", implode ( ", ", $la_WrongIDN ) ) );
				$ls_Result = FALSE;
			}
			if ( count($la_Existing) ) {
				$this->AddMessage ( ERROR, ltext ( "kune5_error18", implode ( ", ", $la_Existing ) ) );
				$ls_Result = FALSE;
			}
			if ( count($la_Reserved) ) {
				$this->AddMessage ( ERROR, ltext ( "kune5_error23", implode ( ", ", $la_Reserved ) ) );
				$ls_Result = FALSE;
			}
			return $ls_Result;
    }

    function AdjustDomains() {
			$la_Domains = $this->GetDomains();
			if ( !is_array($la_Domains) ) return array();
			
			foreach ( array_keys($la_Domains) as $ls_Key ) {
		    $ls_Domain = strtolower ( trim ($la_Domains[$ls_Key]) );
		    if ( ! strlen($ls_Domain) )
					unset ($la_Domains[$ls_Key]);
		    else
					$la_Domains[$ls_Key] = $ls_Domain;
			}
			return array_unique ($la_Domains);
    }
    function AdjustNatDomains() {
			$la_NatDomains = $this->GetNatDomains();
			if ( !is_array($la_NatDomains) ) return array();
			
			foreach ( array_keys($la_NatDomains) as $ls_Key ) {
		    $ls_NatDomain = strtolower ( trim ($la_NatDomains[$ls_Key]) );
		    if ( ! strlen($ls_NatDomain) )
					unset ($la_NatDomains[$ls_Key]);
		    else
					$la_NatDomains[$ls_Key] = $ls_NatDomain;
			}
			return array_unique ($la_NatDomains);
    }

    /* -------------------- end domains -------------------- */





    /* -------------------- ips -------------------- */
    function InitializeIP ()
    {
	$this->ms_CurrentIP = "standard";
	$this->ms_Exclusive = FALSE;
    }

    function SetIPExclusive ( $pa_Data )
    {
	$this->ms_CurrentIP = $pa_Data["ip"];
	$this->ms_Exclusive = array_key_exists ( "exclusiv", $pa_Data ) && $pa_Data["exclusiv"];
    }

    function SetIP ( $ps_UserName )
    {
	if ( strlen($ps_UserName) )
	{
	    $lo_DB =& get_db_connection();
	    $lo_Query =& $lo_DB->Select ( "SELECT ip FROM kunden WHERE kunde = " . db_full_quote($ps_UserName) );
	    if ( $la_Row =& $lo_Query->nextrow() )
		$this->ms_CurrentIP = $la_Row["ip"];
	    else
		$this->ms_CurrentIP = "";
	    if ( !strlen($this->ms_CurrentIP) )
		$lo_DB->Execute ( "UPDATE ipadressen SET kunde = '' WHERE kunde = " . db_full_quote($ps_UserName) );
	}
	else
	    $this->ms_CurrentIP = "standard";
    }

    function SetExclusive ( $ps_UserName )
    {
	$lo_DB =& get_db_connection();
	$lo_Query =& $lo_DB->Select ( "SELECT kunde FROM ipadressen WHERE ip = " . db_full_quote($this->ms_CurrentIP) .
		" AND kunde = " . db_full_quote($ps_UserName) );
	$this->ms_Exclusive = $lo_Query->nextrow() ? TRUE : FALSE;
    }

    function GetIP ()
    {
	return $this->ms_CurrentIP;
    }

    function GetExclusive()
    {
	return $this->ms_Exclusive;
    }

    function ValidateIP ( $pa_Reseller )
    {
	if ( $this->ms_CurrentIP != "standard" )
	{
	    $lo_DB =& get_db_connection();
	    $lo_Query =& $lo_DB->Select ( "SELECT ip FROM ipadressen WHERE anbieter = " .
		    db_full_quote($pa_Reseller["anbieter"]) . " AND kunde = '' AND ip = " .
		    db_full_quote($this->ms_CurrentIP) );
	    if ( !($la_Row =& $lo_Query->nextrow()) )
	    {
		$this->AddMessage ( ERROR, ltext("kune5_error21") );
		return FALSE;
	    }
	    if ( $this->ms_Exclusive )
	    {
		$lo_Query =& $lo_DB->Select ( "SELECT ip FROM kunden WHERE ip = " . db_full_quote($this->ms_CurrentIP) );
		if ( $lo_Query->nextrow() )
		{
		    $this->AddMessage ( ERROR, ltext("kune5_error22") );
		    return FALSE;
		}
	    }
	}
	return TRUE;
    }
    /* -------------------- end ips -------------------- */





    /* -------------------- user registration -------------------- */
    function ValidateRegistration ( $pa_Reseller )
    {
	if ( $pa_Reseller["maxkunden"] < 0 || !$pa_Reseller["maxkundenlimit"] )
	    return TRUE;
	$lo_DB =& get_db_connection();
	$lo_Query =& $lo_DB->Select ( "SELECT COUNT(*)+1 FROM kunden WHERE anbieter = " .
	    db_full_quote($pa_Reseller["anbieter"]) );
	$la_Data =& $lo_Query->nextrow();
	return $pa_Reseller["maxkunden"] >= $la_Data[0];
    }

	function DefineUserNumber()
	{
		global $user_prefix;
		if (!defined($this->ms_Number)) {
			$this->ms_Number = $this->find_new_user_id();	// call to static function
		}
		$this->ms_Name = $user_prefix.$this->ms_Number;
	}

	function SaveIP ( $pa_Reseller ){
		if ( $this->ms_CurrentIP != "standard" ){
	    if ( $this->ms_Exclusive ){
				$lo_DB =& get_db_connection();

				$loFldsUpdate = new SQLFieldSet( new SQLField( 'kunde', $this->ms_Name, 'C'),
																				 new SQLField( 'lastchange', $this->ms_Timestamp)										 
																				 );

				$loFldsWhere = new SQLFieldSet( new SQLField( 'ip', $this->ms_CurrentIP, 'C'),
																				new SQLField( 'anbieter', $pa_Reseller["anbieter"], 'C'),
																				new SQLField( 'kunde', '', 'C')
																				);
				$lcSQL = "UPDATE ipadressen SET ".$loFldsUpdate->getSQLUpdate().
					" WHERE ".$loFldsWhere->getSQLWhere();
					
				$lo_DB->Execute ( $lcSQL );

	    }
		} else {
	    $this->ms_CurrentIP = $pa_Reseller["standardip"];
		}
	}
	
	function AddDomain ( $ps_Domain, $pa_Reseller, $ps_Type, 
											 $ps_DNS=0, $ps_DNR=0 ) {
		$lo_DB =& get_db_connection();

		$loKunde = new SQLField('kunde',$this->ms_Name,'C');

		$loFlds = new SQLFieldSet( new SQLField('domain',$ps_Domain,'C'),
															 $loKunde,
															 new SQLField('anbieter',$pa_Reseller["anbieter"],'C'),
															 new SQLField('richtigedomain',$ps_Type),
															 new SQLField('pfad','/','C'),
															 new SQLField('lastchange',$this->ms_Timestamp),
															 new SQLField('zusatz',$pa_Reseller["httpdspezial"],'C'),
															 new SQLField('dns', $ps_DNS ),
															 new SQLField('dnr', $ps_DNR )
															 );

		list($lcFlds,$lcVls) = $loFlds->getSQLInsert();
		$lcSQL = "INSERT INTO domains ( $lcFlds ) VALUES ( $lcVls )";
		$lo_DB->Execute ( $lcSQL );
		$ls_ID = $lo_DB->getLastID( 'domains', 'id' );

		$lo_DB->Execute( "UPDATE domains SET grp = id WHERE kunde=". $loKunde->getSQLValue().
										 "AND grp!=id AND richtigedomain IN (1,2)");

		domain_aendern ( $ps_Domain, "anlegen", $this->ms_Name );
		fpalias_aendern ( $ps_Domain, "anlegen", $this->ms_Name );

		return $ls_ID;

	}

	function SaveDomains ( $pa_Reseller, $pa_Admin ) {
		$la_Domains = $this->AdjustDomains();
		$la_NatDomains = $this->AdjustNatDomains();
		$lo_DB =& get_db_connection();
		$ls_Template = $ls_Primary = $ls_Secondary = NULL;
		$ls_IDN = $pa_Admin["idn"];
		$ls_SaveIDN = FALSE;

		$lcDnrPhp = dirname(__FILE__) . "/../dnr.php";
		if( file_exists( $lcDnrPhp )	) {
			include_once ( $lcDnrPhp );
		} else {
			$lcDnrPhp = '';
		}

		foreach( $la_Domains as $ls_ID => $ls_Domain ) {
			if ( $ls_IDN ) {
				$ls_Translated = InputDecode::decode ($ls_Domain);
				if ( $ls_Translated != $ls_Domain ) {
					$ls_Domain = translate_name_to_idn ($ls_Translated);
					$ls_SaveIDN = TRUE;
				}	else { 
					$ls_SaveIDN = FALSE;
				}
			}
			$ls_DNS = $pa_Reseller["dns"] && $this->ma_DNS[$ls_ID] ? 1 : 0;
			$ls_DNR = $pa_Reseller["dnr"] && $this->ma_DNR[$ls_ID] ? 1 : 0;
			$ls_ID1 = $this->AddDomain ( $ls_Domain, $pa_Reseller, 1, $ls_DNS, $ls_DNR );
			$ls_ID2 = $this->AddDomain ( "www.".$ls_Domain, $pa_Reseller, 2, 0, 0 );

			if ( $ls_SaveIDN&&isset($this->ma_NatDomains[$ls_ID])&&!empty($this->ma_NatDomains[$ls_ID]) ) {
				save_idn_alias ( $ls_ID1, $this->ma_NatDomains[$ls_ID], FALSE );
				save_idn_alias ( $ls_ID2, "www.".$this->ma_NatDomains[$ls_ID], FALSE );
			}
			if ( $ls_DNS || $ls_DNR ) {
				list($ls_Zonefile, $ls_Serial) = ff_ProcessTemplate ( $pa_Reseller["anbieter"], 
																															$ls_Domain,
																															$this->ms_CurrentIP,
																															NULL,
																															$ls_Template,
																															$ls_Primary,
																															$ls_Secondary 
																															);
				
				$loFlds = new SQLFieldSet( new SQLField( 'domain', $ls_Domain, 'C' ),
																	 new SQLField( 'zonefile', $ls_Zonefile, 'C' ),
																	 new SQLField( 'lastchange', $this->ms_Timestamp),
																	 new SQLField( 'neu', 1 ),
																	 new SQLField( 'anbieter', $pa_Reseller['anbieter'], 'C' ),
																	 new SQLField( 'kunde', $this->ms_Name, 'C')
																	 );

				list($lcFields,$lcVals) = $loFlds->getSQLInsert();
				$lcSQL = "INSERT INTO dns ( $lcFields ) VALUES ( $lcVals )";
				$lo_DB->Execute ( $lcSQL ); 
				
				if ( $ls_DNR && $lcDnrPhp ) {
					
					global $dnr_c_firstname,$dnr_c_gender,$dnr_c_plz,$dnr_c_land,$dnr_c_name,$dnr_c_firma,
						$dnr_c_anschrift,$dnr_c_ort,$dnr_c_telefon,$dnr_c_telefax,$dnr_c_emailadresse,
						$dnr_d_domain,$dnr_d_pns,$dnr_d_sns;
						
					global $dnr_a_firstname,$dnr_a_gender,$dnr_a_plz,$dnr_a_land,$dnr_a_name,$dnr_a_firma,
						$dnr_a_anschrift,$dnr_a_ort,$dnr_a_telefon,$dnr_a_telefax,$dnr_a_emailadresse;

					$dnr_c_firstname = $this->ma_Personal["firstname"]->GetValue();
					$dnr_c_gender = $this->ma_Personal["gender"]->GetValue();
					$dnr_c_plz = $this->ma_Personal["plz"]->GetValue();
					$dnr_c_land = $this->ma_Personal["land"]->GetValue();
					$dnr_c_name = $this->ma_Personal["name"]->GetValue();
					$dnr_c_firma = $this->ma_Personal["firma"]->GetValue();
					$dnr_c_anschrift = $this->ma_Personal["anschrift"]->GetValue();
					$dnr_c_ort = $this->ma_Personal["plzort"]->GetValue();
					$dnr_c_telefon = $this->ma_Personal["telefon"]->GetValue();
					$dnr_c_telefax = $this->ma_Personal["fax"]->GetValue();
					$dnr_c_emailadresse = $this->ma_Personal["emailadresse"]->GetValue();
					$dnr_d_domain = $ls_Domain;
					$dnr_d_pns = $ls_Primary;
					$dnr_d_sns = $ls_Secondary;
					$dnr_a_firstname = $pa_Reseller["firstname"];
					$dnr_a_gender = $pa_Reseller["gender"];
					$dnr_a_plz = $pa_Reseller["plz"];
					$dnr_a_land = $pa_Reseller["land"];
					$dnr_a_name = $pa_Reseller["name"];
					$dnr_a_firma = $pa_Reseller["firma"];
					$dnr_a_anschrift = $pa_Reseller["anschrift"];
					$dnr_a_ort = $pa_Reseller["plzort"];
					$dnr_a_telefon = $pa_Reseller["telefon"];
					$dnr_a_telefax = $pa_Reseller["fax"];
					$dnr_a_emailadresse = $pa_Reseller["emailadresse"];
					sendDnr();
				}
			}
	
			$ls_Domain = $this->ms_Name . "." . $pa_Admin["standarddomain"];
			$lo_DB->Execute ( "DELETE FROM domains WHERE domain = " . db_full_quote($ls_Domain) );
			$this->AddDomain ( $ls_Domain, $pa_Reseller, 3, 0, 0 );
			set_countdomains ( $this->ms_Name );
		}
	}

	function SaveServices ( $pa_Reseller, $pa_Admin ){

		$lo_DB =& get_db_connection();

		$loKunde = new SQLField('kunde',$this->ms_Name,'C');
		$loRes = new SQLField('anbieter',$pa_Reseller["anbieter"],'C');
		
		$loAllgemein = new SQLFieldSet();
		

		if ( array_key_exists("statistik",$this->ma_Services) && 
				 $this->ma_Services["statistik"]->GetValue() ){

			$loFields = new SQLFieldSet( $loKunde, 
																	 new SQLField('loeschen',0), 
																	 new SQLField('neu',1), 
																	 $loRes
																	);

			list($lcFlds,$lcVals) = $loFields->getSQLInsert();
			$lcSQL = "INSERT INTO webalizer ( $lcFlds ) VALUES ( $lcVals )";
			$lo_DB->Execute ( $lcSQL );
			
			$loAllgemein->addField( 'webalizer', 1 );
		}
		
		if ( array_key_exists("perl",$this->ma_Services) && 
				 $this->ma_Services["perl"]->GetValue() )	{

			$loFields = new SQLFieldSet( $loKunde, 
																	 new SQLField('loeschen',0), 
																	 new SQLField('neu',1), 
																	 $loRes
																	 );
			list($lcFlds,$lcVals) = $loFields->getSQLInsert();
			$lcSQL = "INSERT INTO perl ( $lcFlds ) VALUES ( $lcVals )";
			$lo_DB->Execute ( $lcSQL );
			

			$loAllgemein->addField( 'perl', 1 );

		}

		if ( array_key_exists("stdcgi",$this->ma_Services) && 
				 $this->ma_Services["stdcgi"]->GetValue() ) {

			$loAllgemein->addField( 'stdcgi', 1 );

		}

		$lo_DB->Execute( "UPDATE kunden SET httpd = 1 WHERE kunde=".$loKunde->getSQLValue() );


		$loAllgemein->addField( 'adduser', 1 );
		$loAllgemein->addField( 'httpd', 1 );
		$loAllgemein->addField( 'quota', 1 );


		if ( $pa_Admin["neukundenreload"]==1 ){
			$loAllgemein->addField( 'httpdupdate', 0 );
		}

		if ($pa_Admin['spamfilter']) {
			$loAllgemein->addField( 'spamupdate', 1 );
		}

		$lcSQL = "UPDATE allgemein SET ".$loAllgemein->getSQLUpdate();
		
		$lo_DB->Execute( $lcSQL );
	
	}

	function SaveUser ( $pa_Reseller, $ps_UID ){
		global $DEBUG;
		global $lang_short, $kbtyp;

		if( ! $this->ms_Password ){
			$this->ms_Password = mkpasswd(8);
		}

		$ls_Password = crypt_pw ( $this->ms_Password );

		$loFlds = new SQLFieldSet( new SQLField('kunde',$this->ms_Name,'C'),
															 new SQLField('number',$this->ms_Number),
															 new SQLField('uid',$ps_UID),
															 new SQLField('longpw',$ls_Password,'C'),
															 new SQLField('statistiklongpw',$ls_Password,'C'),
															 new SQLField('anbieter',$pa_Reseller["anbieter"],'C'),
															 new SQLField('anmeldedatum',$this->ms_Timestamp),
															 new SQLField('ip',$this->ms_CurrentIP,'C'),
															 new SQLField('quota',1),
															 new SQLField('language',$lang_short,'C'),
															 new SQLField('lastchange',$this->ms_Timestamp),
															 new SQLField('httpdspezial',$pa_Reseller["httpdspezial"],'C'),
															 new SQLField('maxidn',-1)
														 );

		foreach ( $this->ma_Personal as $ls_Key => $lo_Column ){

			$lcName = $lo_Column->GetName();
			if( $lcName ){
				$loFlds->addField( $lcName, $lo_Column->GetValue(), 'C' );

				if( is_a( $lo_Column, 'definablecolumn' ) ) {
					$lcName = $lo_Column->GetLabelName();
					if( $lcName ){
						$loFlds->addField( $lcName, $lo_Column->GetLabelText(), 'C' );
					}
				}					

			}elseif( $ls_Key == 'kundendatenanzeigen' ){
				$loClmn =& $lo_Column->getColumn( 1 );
				if( $loClmn ){
					$loFlds->addField( $loClmn->GetName(), $loClmn->GetValue() );
				}
			}
		}

		foreach ( $this->ma_Services as $ls_Key => $lo_Column ){

			if( $DEBUG ){
				echo "User::SaveUser $ls_Key => ".$lo_Column->GetValue()."<br>\n";
			}

			switch( $ls_Key ){
			case 'maxtransfer':

				$liVal = $lo_Column->GetValue();

				$loFlds->addField( 'maxtransfer', ($liVal>0)? $liVal*1024: $liVal );
				break;

			case 'maxkb':
				$ls_Value = $lo_Column->GetValue();
				if ( $ls_Value >= 0 )
					switch ( $kbtyp ) {
					case "MB":
						$ls_Value *= 1024;
						break;
					case "GB":
						$ls_Value *= 1024 * 1024;
						break;
					}
				$loFlds->addField( 'maxkb', $ls_Value );
				break;

			case 'shell':
				switch ( $lo_Column->GetValue() ){
				case 1:
					$loFlds->addField( 'shell', 1 );
					break;
				case 2:
					$loFlds->addField( 'scponly', 2 );
				}
				break;
					
			default:
				if( $ls_Key ){
					$loFlds->addField( $ls_Key, $lo_Column->GetValue() );
				}
				break;
			}
		}
		
		if( !array_key_exists( 'backup', $this->ma_Services ) ){
			$loFlds->addField( 'backup', 0 );
		}
		
		$lo_DB =& get_db_connection();

		list($lcFlds,$lcVals) = $loFlds->getSQLInsert();
		$lcSQL = "INSERT INTO kunden ( $lcFlds ) VALUES ( $lcVals )";

		return $lo_DB->Execute ( $lcSQL );
	}
		
	function RegisterUser ( $pa_Reseller, $pa_Admin ) {
		$this->ms_Timestamp = time();
		$ls_UID = getuid();
		$this->DefineUserNumber ();
		$this->SaveIP ( $pa_Reseller );
		$this->SaveUser ( $pa_Reseller, $ls_UID );
		freeuid();
		$this->SaveDomains ( $pa_Reseller, $pa_Admin );
		$this->SaveServices ( $pa_Reseller, $pa_Admin );
	}
	/* -------------------- end user registration -------------------- */

/*---------------------- delete user -------------------------*/
	function Delete($ps_Reseller){
		
		global $DEBUG;
		
		$lo_DB =& get_db_connection();
		$kunde=$this->ms_Name;

// check if user exists	
		$sql="select kunde,anbieter from kunden where kunde='$kunde' and anbieter='$ps_Reseller'";
		$lo_Query =& $lo_DB->Select($sql);
		if(!$lo_Query->getNumRows()){
			return FALSE;
		}

		$lo_Query =& $lo_DB->Select("select account from delaccs where account = '$kunde'");
		if(!$lo_Query->getNumRows()){
			db_query("insert into delaccs (account, type, kunde, anbieter) VALUES ('$kunde', 'kunde', '$kunde', '$ps_Reseller')");
		}
		
// pop3 account		
		$lo_Query =& $lo_DB->Select("select account from pop3 where kunde='$kunde' and anbieter='$ps_Reseller'");
		while($la_Row=$lo_Query->nextrow()){
			$account=$la_Row[0];
			$lo_Query =& $lo_DB->Select("select account from delaccs where account = '$account'");
			if(!$lo_Query->getNumRows()){
				db_query("insert into delaccs (account, type, kunde, anbieter) VALUES ('$ccount', 'pop3', '$kunde', '$ps_Reseller')");
			}	

			$lo_DB->Execute("delete from webmail_ab where pop3='$account'");
			$lo_DB->Execute("delete from webmail_session where pop3='$account'");
			$lo_DB->Execute("delete from webmail_sign where pop3='$account'");
		
		}		
		$lo_DB->Execute("delete from pop3 where kunde='$kunde'");
// end pop3 account		

// email	account	
		$lo_DB->Execute("delete from email where kunde='$kunde' and neu = 1");
		$lo_Query =& $lo_DB->Select("select prefix,domain from email where kunde = '$kunde'"); 
		while($la_Row=$lo_Query->nextrow()){
			$account = $la_Row[0];
      $pfad = $la_Row[1];
			$lo_Query =& $lo_DB->Select("select account from delaccs where account = '$account'");
			if(!$lo_Query->getNumRows()){
      	$lo_DB->Execute("insert into delaccs (account, type, kunde, pfad) VALUES ('$account', 'alias', '$kunde', '$pfad')");
			}	
		}		
		$lo_DB->Execute("delete from email where kunde='$kunde'");
// end email account		

// domains
		$lo_Query =& $lo_DB->Select("select domain, id from domains where kunde='$kunde'");
		$la_IDs=array();
		while($la_Row=$lo_Query->nextrow()){
			$domain = $la_Row[0];
			$la_IDs[]=$la_Row[1];
			domain_aendern($domain, "loeschen", $kunde);
			fpalias_aendern($domain, "loeschen", $kunde);
		}
// end domains
// links to domains
		if(count($la_IDs)){
			$ls_idList=implode(',', $la_IDs);
			
			$lo_Query =& $lo_DB->Select("SELECT id FROM maillist WHERE domain_id IN ($ls_idList) AND neu<>3");
			$la_IDs=array();
			while($la_Row=$lo_Query->nextrow()){
				$la_IDs[]=$la_Row[0];
			}
			MailListPage::deleteLists ($la_IDs);
			
			$lo_DB->Execute("DELETE FROM atdomains WHERE id_from IN ($ls_idList)");
			
			$lo_DB->Execute("delete from idn_aliases where domain_id in ($ls_idList)");
			
		}
// end links to domains		

		$lo_DB->Execute("delete from kunden where kunde='$kunde' and anbieter='$ps_Reseller'");
		$lo_DB->Execute("delete from alerts where kunde='$kunde' and anbieter='$ps_Reseller'");
		$lo_DB->Execute("delete from cronjobs where kunde='$kunde'");
		$lo_DB->Execute("delete from domains where kunde='$kunde'");
		$lo_DB->Execute("delete from autoresponder where kunde='$kunde'");
		$lo_DB->Execute("delete from ftp where kunde='$kunde'");
		$lo_DB->Execute("delete from pwschutz where kunde='$kunde'");
		$lo_DB->Execute("delete from htaccess where kunde='$kunde'");
		$lo_DB->Execute("delete from fehlermeldungen where kunde='$kunde'");
		$lo_DB->Execute("delete from perl where kunde='$kunde'");
		$lo_DB->Execute("delete from webalizer where kunde='$kunde'");

		$lo_DB->Execute("update ereignisse set geloescht=1 where kunde='$kunde'");
		$lo_DB->Execute("update cssl set loeschen = 1 where kunde='$kunde'");
		$lo_DB->Execute("update ipadressen set kunde='' where kunde='$kunde' and anbieter='$ps_Reseller'");
		$lo_DB->Execute("update transfer set geloescht=1 where kunde='$kunde'");
		$lo_DB->Execute("update frontpage set loeschen=1, neu=0 where kunde='$kunde'");

		$lo_DB->Execute("update allgemein set deluser=1, delpop=1, httpd=1, aliases=1, dns=1, frontpage=1, cssl=1, frontpagedel=1");

		$lo_Query =& $lo_DB->Select("select dbname from mysql_datenbanken where kunde = '$kunde' and anbieter = '$ps_Reseller'");
		if ($lo_Query->getNumRows()){
			$la_dbnames=array();
			while($la_Row=$lo_Query->nextrow()){
				$la_dbnames[]=$la_Row[0];
			}			
			$lo_DB->Execute("delete from mysql_datenbanken where kunde = '$kunde' and anbieter = '$ps_Reseller'");
			
			@mysql_connect($mysql_user_host, $mysql_user_user, $mysql_user_pass);
			@mysql_select_db("mysql");
			@mysql_query("delete from db where User = '$kunde'");
			@mysql_query("delete from user where User = '$kunde'");

			foreach($la_dbnames as $db){
        @mysql_query("drop database $db");
			}
			
			@mysql_query("FLUSH PRIVILEGES");
			@mysql_close();
		}
		return TRUE;
	}
/*---------------------- end delete user -------------------------*/    

/* ---------------------------- Statistics ---------------------------------*/
	function SetStatistics($pm_Key, $pm_Value=''){
		global $DEBUG;
		if (is_array($pm_Key)){
			foreach($pm_Key as $ls_Key => $lm_Value){
				$this->ma_Statistics[$ls_Key]=$lm_Value;
			}
		}else{
			$this->ma_Statistics[$pm_Key]=$pm_Value;
		}
	}	

	function GetStatistics($ps_Key,$pm_Default=NULL){
		global $DEBUG;
		if(	array_key_exists($ps_Key,$this->ma_Statistics)){
			return $this->ma_Statistics[$ps_Key];
		}else{
			return $pm_Default;	
		}
	}
/* -------------------------- end Statistics -------------------------------*/
	
/* ------------------------ Settings ----------------------*/
	function FillSettings(){
		if($this->ms_Name){
 			$lo_DB =& get_db_connection();
			$lo_Query =& $lo_DB->Select ( "select * from kunden where kunde='".db_quote($this->ms_Name)."'");
	  	$la_Row =& $lo_Query->nextrow();
	  	foreach ($la_Row as $ls_Key => $lm_Value){
	  		$this->ma_Settings[$ls_Key]=$lm_Value;
	  	}
		}
	}
	function GetSettings($ps_Key){
		if(is_array($ps_Key)){
			$lo_Ret=array();
			foreach($ps_Key as $ls_Key){
				if(array_key_exists($ls_Key,$this->ma_Settings)){
					$lo_Ret[$ls_Key]= $this->ma_Settings[$ls_Key];
				}
			}
			return $lo_Ret;
		}else{
			if(array_key_exists($ps_Key,$this->ma_Settings)){
				return $this->ma_Settings[$ps_Key];
			}else{
				return false;
			}
		}
	}
	function CheckLimits($pm_KeySettings,$pm_KeyStatistics=NULL){
		global $DEBUG;
		$ll_Ret=true;
		if(is_array($pm_KeySettings)){
			foreach($pm_KeySettings as $ls_SetKey => $ls_StatKey){
				if(array_key_exists($ls_SetKey,$this->ma_Settings) &&
					array_key_exists($ls_StatKey,$this->ma_Statistics)){
					if(($this->ma_Settings[$ls_SetKey]>-1) && 
						($this->ma_Settings[$ls_StatKey]<$this->ma_Statistics[$ls_StatKey])){
						$ll_Ret=false;	
						break;
					}
				}
			}	
		} else {
			if(array_key_exists($pm_KeySettings,$this->ma_Settings) &&
				array_key_exists($pm_KeyStatistics,$this->ma_Statistics)){
				if(($this->ma_Settings[$pm_KeySettings]>-1) && 
					($this->ma_Settings[$pm_KeySettings]<$this->ma_Statistics[$pm_KeyStatistics])){
					$ll_Ret=false;	
				}
			}	
		}
		return $ll_Ret;
	}
/* ------------------------ end Settings ----------------------*/



	/* -------------------- e-mail -------------------- */
	function ProcessEMail ( $pa_EMail ) {
		$la_Domains = $this->AdjustDomains();
		return preg_replace (
				array (
					"/##kunde##/",
					"/##passwort##/",
					"/##firma##/",
					"/##user##/",
					"/##domain##/",
					"/##domains##/",
					"/##name##/",
					"/##company##/",
					"/##email##/",
					"/##password##/" ),
				array (
					$this->GetName(),
					$this->GetPassword(),
					$this->GetPersonal("firma"),
					$this->GetName(),
					$la_Domains[key($la_Domains)],
					implode( ", ", $la_Domains ),
					$this->GetPersonal("name"),
					$this->GetPersonal("firma"),
					$this->GetPersonal("emailadresse"),
					$this->GetPassword() ),
				array ( $pa_EMail["emailbetreff"], $pa_EMail["emailtext"] ) );
	}
	/* -------------------- end e-mail -------------------- */

	/* static functions (not object methods) */
	
	/* return: minimal free id of end-user
	 */
	function find_new_user_id() // static
	{
		global $user_prefix;

		// select which accounts are going to be deleted, but are not deleted yet
		$id = db_query("SELECT account FROM delaccs WHERE type='kunde'");
		$used_accounts = array();
		while ( $werte = db_fetch_array($id) ) {
			$index = substr ( $werte["account"], strlen($user_prefix) );
			$used_accounts[] = $index;
		}

		$db_res1 = db_query("select kunde from kunden");	 
		while ($row = db_fetch_array($db_res1)) {	 
			$index = substr ( $row["kunde"], strlen($user_prefix) );
			$used_accounts[] = $index; 
		}	 

		sort($used_accounts);	// required (!) for search routine below
		$num_accounts = count($used_accounts);
		$max_used_id = end($used_accounts);

		// I used '<=', because array may include '0' value	
		if ($num_accounts <= $max_used_id) {  
			// look for a missing IDs [ O(n) perfomance ]
			for ($i = 0; $i < $num_accounts; ++$i) {
				if ($used_accounts[$i] > $i) {	
					// no value for this index
					$new_id = $i;
					return $new_id;
				} 
			}
			// this should never happen, but who knows ...
			// todo: write to stderr 
			return $max_used_id + 1;
		} 
		// no skipped IDs in array, use next value
		return $max_used_id + 1;
	}

	/* return: true, if the specified end-user exists 
	   arg $account string, login name to check
	 */
	function if_user_exists($account) 
	{
		// NOTE: for mysql would be better to add "LIMIT 1" 
		// (could seriously increase perfomance)
		$id1 = db_query("select kunde from kunden where kunde = '$account'");	
		// make sure that there are no not-completely deleted users with this name
		$id2 = db_query("select account from delaccs where account = '$account'");

		return (db_num_rows($id1) != 0 || db_num_rows($id2) != 0);
	}
	

	function &Required( $paRequired = NULL ) {
		if( is_array( $paRequired ) ) {
				$this->ma_Required = array();
				foreach ($paRequired as $value)
					$this->ma_Required[] = $value;
			}
		return $this->ma_Required;
	}

	function &AddRequired( $paRequired = NULL ) {
		if( is_string( $paRequired ) ) {
					$this->ma_Required[] = $paRequired;
			}
		return $this->ma_Required;
	}
	
	
}
