<?
include_once( 'class.InputDecode.php' );
include_once( "../include/module.DNSTemplate.php" );
include_once( "../events.inc.php" );
include_once( "../include/event_functions.php" );
include_once( "../include/class.Page.php" );
include_once( "idn_functions.php" );

global $DEBUG;
//$DEBUG=1;

//
// global variables
//
$goUser = new SQLString( $PHP_AUTH_USER );
$goKunde = new SQLString( $kunde );


//
// change user's IP
//

function updateIP( $ip, $exclusiv ) {
	global $fehlertext,$fehlertitel,$kunde;
	global $goUser, $goKunde;

	$id = safe_query2( "SELECT standardip FROM anbieter WHERE anbieter=?", $goUser);
	list( $standardIP ) = db_fetch_array( $id );
	db_close( $id );

	$id = safe_query2( "SELECT standardip, neukundenreload FROM admin" );
	list( $adminIP, $neukundenreload) = db_fetch_array( $id, 'N' );
	db_close( $id );
	if( !$standardIP ) {
		$standardIP = $adminIP;
	}

	if( $ip == 'standard' ){
		$ip = $standardIP;
		$loIP = new SQLString($ip);
    db_query( "UPDATE ipadressen SET kunde = '' WHERE kunde = ?", $goKunde);

	} else {
		$loIP = new SQLString($ip);
		$id = safe_query2( "SELECT COUNT(ip) FROM ipadressen WHERE anbieter=? AND ip=? AND (kunde='' OR kunde=?)",
											 $goUser, $loIP, $goKunde );
		list($count) = db_fetch_array( $id );
		db_close( $id );

		if( !$count ) {
      $fehlertext = ltext("kudoup_error6");
			return 0;
		}
		if ($exclusiv == 1){
			$id = safe_query2( "SELECT COUNT(ip) FROM kunden WHERE ip = ? AND kunde != ?", $loIP, $goKunde);
			list($count) = db_fetch_array($id);
			if ( $count>0 ){
				$fehlertext = ltext("kudoup_error7");
				return 0;
			}
			safe_query2( "UPDATE ipadressen SET kunde = '' WHERE kunde = ? AND anbieter = ?",
									 $goKunde, $goUser);
			safe_query2( "UPDATE ipadressen SET kunde = ? WHERE ip = ? AND anbieter=?",
									 $goKunde, $loIP, $goUser );
		} else {
			safe_query2( "UPDATE ipadressen SET kunde = '' WHERE kunde = ? AND anbieter = ?",
									 $goKunde, $goUser);
		}
	}
	
	$id = safe_query2( "SELECT ip FROM kunden WHERE kunde=?", $goKunde );
	list($oldIP) = db_fetch_array( $id );

	safe_query2( "UPDATE kunden SET ip=?, httpd=1 WHERE kunde=? AND anbieter=?",
							 $loIP, $goKunde, $goUser );
	safe_query2( "UPDATE allgemein SET httpd=1" );

  $fehlertitel = ltext("errtype_notice");
  $fehlertext = ltext("msg_saved_data");

	//
	// change DNS info
	//
	$liResellerDNS = 0;
  $id = safe_query2( "SELECT dns FROM anbieter WHERE anbieter=?", $goUser );
	list( $liResellerDNS ) = db_fetch_array( $id );
	
	if( ( $oldIP != $ip )&&( $liResellerDNS == 1 ) ) {
		$id = safe_query2("SELECT domain, dns FROM domains WHERE kunde=? AND richtigedomain=1", $goKunde);
		while( list( $domain, $dns ) = db_fetch_array( $id, 'N' ) ) {
			updateDNS( $domain, $dns );
		}
	}

	return 1;
}

//
// update DNS info for the domain ( on/off)
//

function updateDNS( $domain, $dns ){
	global $goUser, $goKunde;
	global $fehlertext,$fehlertitel;
	global $DEBUG;
	global $kunde, $PHP_AUTH_USER;
	if($DEBUG){
		
		echo "updateDNS: domain=$domain, dns=$dns<br>\n";
		
	}

	$id = safe_query2( "SELECT dns, standardip, dnsspezial FROM anbieter WHERE anbieter=?", $goUser);
	list( $skdns, $standardip, $dnstemplate ) = db_fetch_array( $id, 'N');
	db_close( $id );

	if( $skdns == 0 ){
		$fehlertext = "Reseller can't setting up DNS";
		return 0;
	}

	if(is_numeric($domain)){
		$domain_id = $domain;
		$id = safe_query2( "SELECT domain FROM domains WHERE id=?", new SQLInteger($domain_id));
		list( $domain ) = db_fetch_array( $id );
	}
	$loDomain = new SQlString( $domain );

	if( $dns ){

		if( !$standardip ){
			$id = safe_query2( "SELECT standardip FROM admin" );
			list( $standardip ) = db_fetch_array( $id, 'N');
			db_close( $id );
		}
		
		$id = safe_query2( "SELECT ip FROM kunden WHERE kunde=?",$goKunde);
		list($ip) = db_fetch_array($id);
		db_close( $id );
		if( !$ip ) {
			$ip = $standardip;
		}

		list( $zonefile, $seriennummer ) = ff_ProcessTemplate ( $PHP_AUTH_USER, $domain, $ip,
																														NULL, $dnstemplate, $pns,	$sns );
		$id = safe_query2( "SELECT COUNT(*) FROM dns WHERE domain=?", $loDomain);
		list($count) = db_fetch_array($id);
		db_close( $id );
		
		$loFields = new SQLFieldSet(array( 'zonefile' => array( $zonefile, 'C' ),
																			 'lastchange' => $seriennummer,
																			 'neu' => 1,
																			 'kunde' => array( $kunde, 'C' ),
																			 'anbieter' => array( $PHP_AUTH_USER, 'C' )
																			 )
																);
		
		if ( $count > 0 ) {
			$sql = "UPDATE dns SET ".$loFields->getSQLUpdate()." WHERE domain=?";
		} else {
			list( $lcFlds, $lcVals ) = $loFields->getSQLInsert();
			$sql = "INSERT INTO dns ($lcFlds,domain) VALUES ($lcVals,?)";
		}

		safe_query2( $sql, $loDomain );

	} else {
    safe_query2( "UPDATE dns SET neu=2, kunde=?, anbieter=? WHERE domain = ?",
								 $goKunde, $goUser, $loDomain );

	}

	safe_query2( "UPDATE allgemein SET dns=1" );
	
}


//
// send DNS request for the domain
//

$gaUser = array();
$gaReseller = array();

function sendDNSRequest( $domain ){
	global $goKunde, $goUser, $kunde;
	global $fehlertext, $fehlertitel;
	global $gaUser, $gaReseller;
	
	global $dnr_c_firstname,$dnr_c_gender,$dnr_c_plz,$dnr_c_land,$dnr_c_name,$dnr_c_firma,
		$dnr_c_anschrift,$dnr_c_ort,$dnr_c_telefon,$dnr_c_telefax,$dnr_c_emailadresse,
		$dnr_d_domain,$dnr_d_pns,$dnr_d_sns;

	global $dnr_a_firstname,$dnr_a_gender,$dnr_a_plz,$dnr_a_land,$dnr_a_name,$dnr_a_firma,
		$dnr_a_anschrift,$dnr_a_ort,$dnr_a_telefon,$dnr_a_telefax,$dnr_a_emailadresse;

	
	if( !file_exists("../dnr.php") ) {
		return 0;
	}
	include_once("../dnr.php");

	if( is_numeric( $domain ) ) { 
		$domain_id = $domain;
		$id = safe_query2( "SELECT domain FROM domains WHERE id=?", new SQLInteger($domain_id));
		list( $domain ) = db_fetch_array( $id );
	}

	
	$loDomain = new SQLString( $domain );
	safe_query2 ( "UPDATE domains SET dnr=1 WHERE domain=? AND kunde=? AND anbieter=?",
								$loDomain, $goKunde, $goUser );

	if( !count( $gaReseller ) ) {
		$id = safe_query2( "SELECT gender,plz,firstname,land,name,firma,anschrift,plzort,".
											 "telefon,fax,emailadresse,pns,sns FROM anbieter WHERE anbieter = ?", $goUser);

		$gaReseller = db_fetch_array($id);
		db_close( $id );
	}

	$dnr_a_firstname    = $gaReseller["firstname"];
	$dnr_a_gender       = $gaReseller["gender"];
	$dnr_a_plz          = $gaReseller["plz"];
	$dnr_a_land         = $gaReseller["land"];
	$dnr_a_name         = $gaReseller["name"];
	$dnr_a_firma        = $gaReseller["firma"];
	$dnr_a_anschrift    = $gaReseller["anschrift"];
	$dnr_a_ort          = $gaReseller["plzort"];
	$dnr_a_telefon      = $gaReseller["telefon"];
	$dnr_a_telefax      = $gaReseller["fax"];
	$dnr_a_emailadresse = $gaReseller["emailadresse"];

	$pns = $gaReseller['pns'];
	$sns = $gaReseller['sns'];


	if(!count($gaUser)){
		$id = safe_query2( "SELECT gender,plz,firstname,land,name,firma,anschrift,plzort,".
										 "telefon,fax,emailadresse FROM kunden WHERE kunde = ?", $goKunde );

		$gaUser = db_fetch_array($id);
		db_close( $id );
	}

	$dnr_c_firstname    = $gaUser["firstname"];
	$dnr_c_gender       = $gaUser["gender"];
	$dnr_c_plz          = $gaUser["plz"];
	$dnr_c_land         = $gaUser["land"];
	$dnr_c_name         = $gaUser["name"];
	$dnr_c_firma        = $gaUser["firma"];
	$dnr_c_anschrift    = $gaUser["anschrift"];
	$dnr_c_ort          = $gaUser["plzort"];
	$dnr_c_telefon      = $gaUser["telefon"];
	$dnr_c_telefax      = $gaUser["fax"];
	$dnr_c_emailadresse = $gaUser["emailadresse"];
	## domaindaten:
	$dnr_d_domain       = $domain;
	$dnr_d_pns          = $pns;
	$dnr_d_sns          = $sns;
                    ## adminvariablen:
	sendDnr();
	
	return 1;
}

//
// append new domain
//

function appendDomain( $domain, $dns, $dnr ){
	global $goUser, $goKunde;
	global $fehlertext,$fehlertitel,$kunde;
	global $user_prefix;

	$id = db_query( "SELECT standarddomain, idn, userprefix,standardip FROM admin" );
	$werte = db_fetch_array($id);
	db_close( $id );

	$stddomain = $werte["standarddomain"];
	$user_prefix = $werte["userprefix"];
	$idn_support = $werte["idn"];
	$stdip = $werte["standardip"];

	$id = safe_query2( "SELECT maxdomains, maxdomainslimit, httpdspezial, dns, dnr,standardip ".
											" FROM anbieter WHERE anbieter=?",
											$goUser );

	$werte = db_fetch_array($id);
	db_close( $id );

	$maxdomains = $werte["maxdomains"];
	$maxdomainslimit = $werte["maxdomainslimit"];
	$httpdspezial = $werte["httpdspezial"];
	$skdns = $werte["dns"];
	$skdnr = $werte["dnr"];
	if(!$stip){
		$stip = $werte["standardip"];
	}

	$id = safe_query2( "SELECT ip FROM kunden WHERE kunde=?", $goKunde );
	list($ip) = db_fetch_array($id);
	db_close( $id );

	if(!$ip){
		$ip = $stip;
	}


#
# check if reseller can add the new domain
#
	$id = safe_query2( "SELECT COUNT(domain) FROM domains WHERE anbieter=? AND richtigedomain=1",
										 $goUser );
	list($count) = db_fetch_array( $id );
	db_close( $id );
	
	if (($count >= $maxdomains) && ( $maxdomainslimit == 1) && ( $maxdomains >=0 ) ) {
		$fehlertext = ltext("kudoup_error3",array($maxdomains,$anzahldomains));
		return 0;
	}

	
#
# IDN
#
	$lcTmp = $domain;
	$lcDomainTranslated = InputDecode::decode( $domain );
	if ( $domain != $lcDomainTranslated ) {
		if ( $idn_support ) {
			// has national characters
			$domain = translate_name_to_idn($lcDomainTranslated); 
		} else {
			// has national characters, but there are no IDN support
			// try to get name from database
			$res_idn = safe_query2( "SELECT d.domain FROM domains d, idn_aliases idn WHERE ".
															"idn.domain_id = d.id AND idn.idn_name = ?",
															new SQLString($lcDomainTranslated) );
			if (db_num_rows($res_idn) > 0) {
				$fehlertext = ltext("kudoup_error4",array( $lcDomainTranslated ) );
				return 0;
			} else {
				$fehlertext = ltext('error_bad_domains__no_idn_support', array( $domain ));
				return 0;
			}
		}
	} else {
		$lcDomainTranslated = '';
	}


#
# check syntax
#
	$domain = strtolower(trim($domain));
	if ( ! preg_match( '/^[^\.]+(\.[^\.]+)+$/', $domain ) || 
					 preg_match( '/^www\./', $domain ) 
					 ) {
		
		$fehlertext = ltext("kune5_error19", array($domain));
		return 0;
  }

	$dname_regexp = "/${user_prefix}[0-9]+\." . str_replace('.', '\.', $stddomain) . "/i";
	if(preg_match($dname_regexp, $domain)){
		$fehlertext = ltext("kune5_error23", array( $omain, $user_prefix, $stddomain));
		return 0;
	}


#
# check if there is this domain already
#
	$loDomain = new SQLString( $domain );
	$id = safe_query2(" SELECT COUNT(domain) FROM domains WHERE domain=?", $loDomain);
	list($count) = db_fetch_array( $id );
	db_close( $id );

	if( $count ){
		$fehlertext = ltext("kudoup_error4",array($domain));
		return 0;
	}
	
	$timestamp = time();
	$dns = $dns && $skdns;
	$dnr = $dnr && ( $skdns && $skdnr );
	
	$sql="INSERT INTO domains (domain, kunde, anbieter, richtigedomain, pfad, ".
		"lastchange, zusatz, dns, dnr) VALUES (?, ?, ?, 1, '/', $timestamp, ?, ?, ?)";

	$loSpezial = new SQLString($httpdspezial);
	$res1 = safe_query2( $sql, $loDomain, $goKunde, $goUser, 
											 $loSpezial, new SQLInteger($dns), new SQLInteger( $dnr));
	global $db_type;
	if($db_type=='mysql'){
		$id1  = db_insert_id( $res1 );
	}else{
		$id1  = db_insert_id( 'domains','id');
	}
	db_close($res1);

	domain_aendern($domain, "anlegen", $kunde);
	fpalias_aendern($domain, "anlegen", $kunde);

	$sql = "INSERT INTO domains (domain, kunde, anbieter, richtigedomain, pfad, ".
		"lastchange, zusatz, dns, dnr) VALUES (?, ?, ?, 2, '/', $timestamp, ?, 0, 0)";
	$res2 = safe_query2( $sql, new SQLString( 'www.'.$domain ), $goKunde, $goUser, $loSpezial);

	if($db_type=='mysql'){
		$id2  = db_insert_id($res2);
	}else{
		$id2  = db_insert_id('domains','id');
	}
	db_close($res2);

	safe_query2("UPDATE domains SET grp=id WHERE richtigedomain IN (1,2) ".
							" AND grp!=id AND kunde=?", $goKunde );

	domain_aendern( "www.".$domain, "anlegen", $kunde);
	fpalias_aendern( "www.".$domain, "anlegen", $kunde);

	if( $lcDomainTranslated ) {
			include_once('idn_functions.php');
//		save_idn_alias($id1, $lcDomainTranslated, false);
//		save_idn_alias($id2, 'www.'.$lcDomainTranslated, false);
		save_idn_alias($id1, $lcTmp, false);
		save_idn_alias($id2, 'www.'.$lcTmp, false);
	}

	if( $dns ){
		updateDNS( $domain, $dns );
	}
	if( $dnr ){
		sendDNSRequest( $domain );
	}

## //
  set_countdomains( $kunde );
## //

  safe_query2( "UPDATE kunden SET changedomains = 1, httpd=1 WHERE kunde = ? AND anbieter = ?",
							 $goKunde, $goUser );

  if ( $neukundenreload == 1 ) {
    db_query("UPDATE allgemein SET httpd=1, httpdupdate=0");
  } else{
    db_query("UPDATE allgemein SET httpd=1");
  }


	return 1;
}

//
// batch deleting of domains
//

function deleteDomains( &$domain_ids, $update_db = FALSE ){
	global $goUser, $goKunde;
	global $kunde;

	$laToDelete = array();

	foreach( $domain_ids as $id) { // loop by domains

		$loDomainID = new SQLInteger( $id );

		//
		// DNS update
		//

		$sql = "SELECT d.domain, d.dns, d.dnr, dns.neu, not(dns.kunde IS NULL) AS dns_inserted ".
			" FROM domains d  LEFT JOIN dns ON dns.domain=d.domain AND dns.kunde=d.kunde ".
			" WHERE d.richtigedomain = 1 AND d.kunde = ? AND d.anbieter=? AND d.id = ?";
		$res = safe_query2( $sql, $goKunde, $goUser, $loDomainID );
		list( $domain, $dns, $neu, $dns_inserted ) = db_fetch_array( $res, 'N' );
		db_close( $res );


		if( $update_db && $dns ){ // switch off DNS
			updateDNS( $domain, 0 );
		}
		
		//
		// get list of subdomains
		//

		$laSubdomains = array();
		$loDomains = new SQLFieldSet();

		$res = safe_query2( "SELECT domain, id FROM domains WHERE richtigedomain != 1 AND ".
												"kunde=? AND anbieter=? AND domain LIKE ? ", $goKunde, $goUser, new SQLString('%.'.$domain) );
		while(list($subdomain,$subid) = db_fetch_array( $res ) ){
			$laSubdomains[$subdomain] = $subid; 
			$loDomains->addField( $subid, $subdomain, 'C');
		}
		db_close( $res );

		$laToDelete[$domain] = array($laSubdomains);

		$laSubdomains[$domain] = $id; 
		$loDomains->addField( $id, $domain, 'C');
		
		$lcDomains = $loDomains->getSQLValues();

		//
		// get list of emails
		//
		$laEmails = array();
		$res = safe_query2( "SELECT ident, prefix, domain FROM email WHERE domain IN ($lcDomains) ".
												"AND kunde = ? AND anbieter = ?",
												$goKunde, $goUser );
		while( list( $ident,$prefix,$edomain ) = db_fetch_array( $res, 'N' ) ) {
			$laEmails[$prefix.'@'.$edomain] = $ident;
		}
		db_close( $res );

		$laToDelete[$domain][] = $laEmails;

		if( $update_db && count( $laEmails ) ) {
			$loFields = new SQLFieldSet( array( 'account' => array( '','C'),
																					'type' => array( 'alias','C'),
																					'kunde' => array( $kunde, 'C'),
																					'pfad' => array( '', 'C' )
																					)
																	 );
			$lcFlds = $loFields->getSQLNames();
			foreach( $laEmails as $email => $ident ) {

				list( $prefix, $edomain ) = split( '@', $email, 2 );

				$loFields->updateField( 0, $prefix );
				$loFields->updateField( 3, $edomain );

				$lcVals = $loFields->getSQLValues();

				safe_query2( "INSERT INTO delaccs( $lcFlds ) VALUES ( $lcVals )" );
			}							 
			
			$lcIDs = join(',',array_values($laEmails));

			safe_query2( "DELETE FROM autoresponder WHERE kunde=? AND ident IN ($lcIDs)", $goKunde );					 
			safe_query2( "DELETE FROM email WHERE kunde=? AND anbieter=? AND ident IN ($lcIDs)", $goKunde, $goUser );					 
			safe_query2( "DELETE FROM email_forward WHERE kunde=? AND email_ident IN ($lcIDs)", $goKunde );					 

		}

		//
		// get list of at-domains
		//
		$lcDomainIDs = join(',',array_values($laSubdomains));
		$laAtDomains = array();
		$res = safe_query2( "SELECT a.id, a.name, d.domain FROM atdomains a, domains d ".
												" WHERE d.kunde =? AND d.anbieter=? ".
												" AND a.id_from=d.id AND d.id IN ( $lcDomainIDs )",
												$goKunde, $goUser );
		while( list( $atid,$name,$atdomain ) = db_fetch_array( $res, 'N' ) ){
			$laAtDomains[$name.'@'.$atdomain] = $atid;
		}
		db_close( $res );

		$laToDelete[$domain][] = $laAtDomains;

		if( $update_db && count( $laAtDomains ) ) {
			$lcIDs = join(',',array_values($laAtDomains));
			safe_query2( "DELETE FROM atdomains WHERE id IN ($lcIDs)" );
		}

		//
		// get list of maillists
		//
		$laMailists = array();

		$res = safe_query2( "SELECT m.id, m.name, d.domain FROM maillist m, domains d ".
												" WHERE m.domain_id=d.id ".
												" AND d.id IN ( $lcDomainIDs ) AND kunde=? AND anbieter=?",
												$goKunde, $goUser );
		while( list( $mlid, $name, $mldomain ) = db_fetch_array( $res, 'N' ) ){
			$laMaillists[$name.'@'.$mldomain] = $mlid;
		}
		db_close( $res );


		$laToDelete[$domain][] = $laMaillists;


		if( $update_db && count( $laMaillists ) ) {
			MailListPage::deleteLists ( array_values($laMaillists) );
		}

		if( $update_db ) {
			foreach( array_keys($laSubdomains) as $domain ) {
				domain_aendern($domain, "loeschen", $kunde);
				fpalias_aendern($domain, "loeschen", $kunde);
			}

			safe_query2( "DELETE FROM idn_aliases WHERE domain_id IN ( $lcDomainIDs ) ");		
			safe_query2( "DELETE FROM domains WHERE id IN ($lcDomainIDs) AND kunde=? AND anbieter=?",
									 $goKunde, $goUser );
		}
	}

	if( $update_db ) {
		$res = db_query("SELECT neukundenreload FROM admin");
		list($neukundenreload) = db_fetch_array($res);

		db_query("UPDATE kunden SET httpd=1 WHERE kunde=?", $goKunde);

		if($neukundenreload==1){
			db_query("UPDATE allgemein SET dns=1, httpd=1, httpdupdate=0");
		} else {
			db_query("UPDATE allgemein SET dns=1, httpd=1");
		}
		set_countdomains($kunde);
		safe_query2( "UPDATE kunden SET changedomains = 1 WHERE kunde = ? AND anbieter = ?", 
								 $goKunde, $goUser);
	} else {

		if($DEBUG){
			/*
			 echo "<br><pre>\n";
			 print_r($laToDelete);
			 echo "</pre><hr>\n";
			*/
		}

		if( count( $laToDelete ) ) {
			$loRD = new SetOfRowsData();
			foreach ( $laToDelete as $domain => $laItems ) {
				if ( $idn_str = get_html_idn_name( $domain ) ) {
					$domain = $idn_str;
				}

				$loRD->AppendHeaderRow( new HTMLDataField($domain) );

				list($laSubDomains,$laEmails,$laAtDomains,$laMailLists) = $laItems;

				if(count($laSubDomains)){
					$loRD->AppendHeaderRow( new HTMLDataField( ltext('kudoup_title4') ) );
					foreach($laSubDomains as $subdomain => $id){
						if( $idn_str = get_html_idn_name( $subdomain ) ) {
							$subdomain = $idn_str;
						}

						$loRD->AppendRow( new HTMLDataField($subdomain));
					}
				}

				if(count($laEmails)){
					$loRD->AppendHeaderRow( new HTMLDataField( ltext('kudoup_title5') ) );
					foreach($laEmails as $email => $id){
						$loRD->AppendRow( new HTMLDataField($email));
					}
				}

				if(count($laMailLists)){
					$loRD->AppendHeaderRow( new HTMLDataField( ltext('kudoup_title6') ) );
					foreach($laMailLists as $email => $id){
						$loRD->AppendRow( new HTMLDataField($email));
					}
				}

			}
			foreach ($domain_ids as $id){
				$loRD->AppendHidden( new TextDataField( $id, 'domain_ids[]' ) );
			}

			$loRD->AppendHidden( new TextDataField( 1, 'update_db' ) );
			$loRD->AppendHidden( new TextDataField( $kunde, 'kunde' ) );
			$loRD->AppendHidden( new TextDataField( '', 'action' ) );

			$loRD->AppendButton( ltext('kudoup_button1'),
													 "javascript:submitForm('action','delete');",
													 c_IDOK );

			$loForm = $loRD->GetInputPresentation( array( 'action'=>'kunden_domains.php',
																										'method'=>'post',
																										'name' => 'confirm_delete'),
																						 ltext('kudoup_title3').$kunde
																						 );
			$page = new MainPageElement( $loForm );
			$page->OutputHTML( array( '../../js/paged_form.js' ));

			exit;
		}
	}
}


//
// batch changing of DNS status
//

function batchDNSDNR( &$domain_ids, $dnsdnr ){
	global $goUser, $goKunde;
	global $DEBUG;

	/*
	if($DEBUG){
		echo "batchDNSDNR: dnsdnr: $dnsdnr<br><pre>\n";
		print_r($domain_ids);
		echo "</pre><hr>\n";
	}
	*/

	foreach ($domain_ids as $id){ // loop by domains

		$id = safe_query2( "SELECT d.domain,d.dns,dns.neu FROM domains d ".
											 " LEFT JOIN dns ON dns.domain=d.domain ".
											 " WHERE d.kunde=? AND d.anbieter=? AND d.id=?",
											 $goKunde, $goUser, new SQlInteger($id));
		list($domain,$dns,$neu) = db_fetch_array( $id, 'N');
		if( is_null( $neu ) ) {
			$neu = -1;
		} 

		db_close( $id );

		switch( $dnsdnr ){
		case 1:
			if(  !( $neu == 1) ){ // switch on dns
				updateDNS( $domain, 1 );
			}
			break;
		case 2:
			if( $dns && !($neu==2 || $neu==-1) ){ // switch off dns
				updateDNS( $domain, 0 );
			}
			break;
		case 3: // send DNR
			sendDNSRequest( $domain );
			break;
		case 4:
			if( !($neu == 1) ){ // switch on dns & send DNR
				updateDNS( $domain, 1 );
				sendDNSRequest( $domain );
			}
			break;
		}
	}
}

?>
