<?

########## Confixx(R) 3.1 Professional ############
####### Copyright SWsoft, Inc. 2004-2005 ##########
#### http://www.swsoft.com - info@swsoft.com ####

/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/


include_once ( dirname(__FILE__) . '/module.Database.php' );
include_once ( dirname(__FILE__) . '/class.User.php' );
include_once ( dirname(__FILE__) . '/class.Actor.php' );
include_once ( dirname(__FILE__) . '/class.InputDecode.php' );



class Reseller extends Actor {

    /* -------------------- Members -------------------- */
    var $ma_Data; // data from anbieter table
    var $ma_Users; // user's list of reseller
    var $ma_UserOrder;

		var $miDomainsCount; // number of reseller's domains
    /* -------------------- end Members -------------------- */



    /* -------------------- Constructor -------------------- */
    function Reseller ( $ps_Name = NULL ){
			global $PHP_AUTH_USER;

			$this->Actor();

			$this->ms_Name = is_null($ps_Name) ? $PHP_AUTH_USER : $ps_Name;
			$lo_DB =& get_db_connection();
			$lo_Query =& $lo_DB->Select ( "SELECT * FROM anbieter WHERE anbieter='" .
																		db_quote($PHP_AUTH_USER) . "'" );
			$this->ma_Data =& $lo_Query->nextrow();
    }
    /* -------------------- end Constructor -------------------- */





    /* -------------------- Methods -------------------- */
    function IsMyUser ( $ps_UserName ){
			$lo_DB =& get_db_connection();
			$lo_Query =& $lo_DB->Select ( "SELECT kunde FROM kunden WHERE kunde='" . db_quote($ps_UserName) .
																		"' AND anbieter='" . db_quote($this->ms_Name) . "'" );
			return $lo_Query->getNumRows();
    }

    function CanAddDomains ( $piCount=0){
			if ( $this->ma_Data["maxdomainslimit"] != 1 || $this->ma_Data["maxdomains"] == -1 )
				return TRUE;

			$id = safe_query2( "SELECT COUNT(id) as cnt FROM domains ".
												 " WHERE anbieter=? AND richtigedomain = 1", 
												 new SQLString($this->ms_Name) 
												);

			list( $this->miDomainsCount ) = db_fetch_array( $id );
			if( is_array( $piCount ) ) {
				$piCount = count($piCount);
			}

			$this->miDomainsCount += $piCount;

			return $this->miDomainsCount < $this->ma_Data["maxdomains"];
    }

    function &GetField ( $ps_Name ){
			return $this->ma_Data[$ps_Name];
    }

		function &GetFields(){
			return $this->ma_Data;
		}

    function GetFieldForSQL ()
    {
	
    }
    
    function FillUserList (){
    	$lo_DB =& get_db_connection();
			$lo_Query =& $lo_DB->Select ( "select kunde from kunden where ".
																		"anbieter='". db_quote($this->ms_Name) . "' order by number" );
			$this->ma_Users=array();
			$this->ma_UserOrder=array();
			$li_UserNumber=0;
			while ($la_Row =& $lo_Query->nextrow()){
				$this->ma_Users[$la_Row[0]]=& new User($la_Row[0]);
				$this->ma_UserOrder[$la_Row[0]]=++$li_UserNumber;
			}
			return $li_UserNumber;
    }
    
    function GetUsersList(){
    	return $this->ma_Users;
    }

    function GetUser($ps_UserName){
    	if(array_key_exists($ps_UserName, $this->ma_Users)){	
    		return $this->ma_Users[$ps_UserName];
    	}else{
    		return false;	
    	}
    }
    
    function SetUserStatistics($ps_Key,$pa_Values){
    	global $DEBUG;
    	foreach (array_keys($this->ma_Users) as $lo_UserName) {
    		$lo_User =& $this->ma_Users[$lo_UserName];
    		if(array_key_exists($lo_UserName,$pa_Values)){
    			$lo_User->SetStatistics($ps_Key,$pa_Values[$lo_UserName]);
    		}
    	}
    }

    function GetUserStatistics($ps_Key){
    	global $DEBUG;
    	$la_ret=array();
    	foreach (array_keys($this->ma_Users) as $lo_UserName) {
    		$lo_User =& $this->ma_Users[$lo_UserName];
   			$la_ret[$lo_UserName]=$lo_User->GetStatistics($ps_Key);
    	}
    	return $la_ret;
    }

    
    function CalcUserStatistics($ps_Key,$ps_sql){
    	
    	global $DEBUG;
    	
  		$lo_DB =& get_db_connection();
			$lo_Query =& $lo_DB->Select ( $ps_sql);
			if($lo_Query){
	  		while($la_Row =& $lo_Query->nextrow()){
	  			$la_UserName=$la_Row[0];
	  			$la_Value = $la_Row[1];

	  			if(array_key_exists($la_UserName, $this->ma_Users)){	
	  				$lo_User =& $this->ma_Users[$la_UserName];
    				$lo_User->SetStatistics($ps_Key,$la_Value);
    			}
    		}
	  	}else{
	  		echo "Reseller.CalcUserStatistics: error sql query: $ps_sql<br>\n";
	  	}
    }
    
    function SetUserOrder($ps_key,$ps_desc=''){
    	if($ps_key == 'number'){
    		foreach ($this->ma_Users as $la_UserName => $lo_User){
    			$this->ma_UserOrder[$la_UserName]=$lo_User->GetUserNumber();
    		}
    	}	elseif ($ps_key == 'name')	{
	    	foreach (array_keys($this->ma_Users) as $lo_UserName) {
  	  		$lo_User =& $this->ma_Users[$lo_UserName];
    			$this->ma_UserOrder[$la_UserName]=$lo_User->GetUserName();
    		}
    	}else{
	    	foreach (array_keys($this->ma_Users) as $lo_UserName) {
  	  		$lo_User =& $this->ma_Users[$lo_UserName];
    			$this->ma_UserOrder[$la_UserName]=$lo_User->GetStatistics($ps_key);
    		}
    	}
    	if(stristr($ps_desc,'desc')){
    		arsort($this->ma_UserOrder,SORT_NUMERIC);
    	}else{
    		asort($this->ma_UserOrder,SORT_NUMERIC);
    	}
    	return $this->ma_UserOrder;
    }
    
    function GetUserOrder(){
    	return array_keys($this->ma_UserOrder);
    }
    
#
# check domain's name 
# return: value for storing into database
#
		function validateDomain( $pcDomain, $piCount=0 ){

			global $DEBUG;
			

			if( is_array( $piCount ) ) {
				$laDomains = $piCount;
				$piCount = count($laDomains);
			}else{
				$laDomains = array();
			}

			$pcDomain = strtolower(trim($pcDomain));

			if( ! $pcDomain){ /* name of the domain is empty */
				$this->AddMessage ( ERROR, ltext( 'kune5_error16' ) );
				return $pcDomain;
			}

			if( ! $this->CanAddDomains( $piCount ) ){ /* can't add new domain: limit is exceeded */
				$this->AddMessage ( ERROR, ltext( 'kune5_error17', 
																					$this->ma_data['maxdomains'], 
																					$this->miDomainsCount ) );
				return FALSE;
			}

    	$lo_DB =& get_db_connection();

			$lo_Query =& $lo_DB->Select ( "SELECT standarddomain, idn FROM admin" );
			$la_Admin =& $lo_Query->nextrow();

#
# IDN-domain
#
			$ls_Translated = InputDecode::decode( $pcDomain );
			if( $ls_Translated != $pcDomain ){

				if ( $la_Admin["idn"] ){
					$pcDomain = translate_name_to_idn ( $ls_Translated);
				} else {
					$this->AddMessage ( ERROR, ltext( "error_bad_domains__no_idn_support", $pcDomain  ) );
					return NULL;
				}
			}
				
			
#alr
# syntax
#
			if ( ! preg_match( '/^[^\.]+(\.[^\.]+)+$/', $pcDomain ) || 
					 preg_match( '/^www\./', $pcDomain ) 
					 ) {
				
				$this->AddMessage ( ERROR, ltext( 'kune5_error19', $pcDomain ) );
				return NULL;

			}

#
# resereved names
#
			$ls_Expression = "/^${user_prefix}[0-9]+\." . str_replace( ".", "\.", $la_Admin["standarddomain"] ) . "$/i";

			if ( preg_match ( $ls_Expression, $pcDomain ) ) {

				$this->AddMessage ( ERROR, ltext( 'kune5_error23', $pcDomain ) );
				return NULL;
			}

#
# already exists
#
			$lo_Query =& $lo_DB->Select ( "SELECT domain FROM domains WHERE domain = " . 
																		db_full_quote( $pcDomain ) );
			if ( $lo_Query->nextrow() ||
					 in_array( $pcDomain, $laDomains )
					 ){
				$this->AddMessage ( ERROR, ltext( 'kune5_error18', $pcDomain ) );
				return NULL;
			}
			
			// If already exists in DNS
			$lo_Query =& $lo_DB->Select ( "SELECT domain FROM dns WHERE domain = " . 
																		db_full_quote( $pcDomain ) );
			if ( $lo_Query->nextrow() ||
					 in_array( $pcDomain, $laDomains )
					 ){
				$this->AddMessage ( ERROR, ltext( 'kune5_error18', $pcDomain ) );
				return NULL;
			}

		return $pcDomain;

		}
     
    /* -------------------- end Methods -------------------- */

}
?>
