<?
/*
  -------------------- Name conventions --------------------
  Function names (except methods):

  ff_DescriptionOfFunction


  Constant names:

  cc_DescriptionOfConstant


  Variable names:

  $ST_DescriptionOfVariable

  where S is a scope, T is a type.

  The following scopes should be used:
  g - global
  s - static
  l - local
  m - member of class
  p - parameter

  The following types should be used:
  s - scalar
  a - array
  r - resource
  o - object
  m - mixed

  -------------------- end Name conventions --------------------
*/





include_once ( dirname(__FILE__) . "/../class.PersonalInfo.php" );





class AdminPersonalInfo extends PersonalInfo{

    /* -------------------- Members -------------------- */
    var $ms_FirstTime; // if page is shown at first time
    /* -------------------- end Members -------------------- */





    /* -------------------- Constructor -------------------- */
    function AdminPersonalInfo ( $ps_FormURL, $ps_DB, $ps_FirstTime )
    {
	$this->PersonalInfo ( $ps_FormURL,
		$ps_DB ? "SELECT personalinfo.* FROM personalinfo LEFT JOIN admin ON personalinfo.id=admin.personalinfoid"
		: NULL );
	$this->ms_FirstTime = $ps_FirstTime;
    }
    /* -------------------- end Constructor -------------------- */





    /* -------------------- SaveData -------------------- */
    function SaveData()
    {
	global $gender, $firstname, $name, $firma, $anschrift, $plzort, $plz, $land, $telefon, $fax, $emailadresse,
		$kundennummer, $freifeldname1, $freifeldwert1, $freifeldname2, $freifeldwert2, $freifeldname3,
		$freifeldwert3, $kundendatenanzeigen;

	$kundendatenanzeigen = $kundendatenanzeigen? 1: 0;

	$lo_DB =& get_db_connection();
	$lo_DB->lockTables ( NULL, array( "admin", "personalinfo" ) );
	$lo_Query =& $lo_DB->Select ( "SELECT admin.personalinfoid FROM admin, personalinfo WHERE
		personalinfo.id=admin.personalinfoid" );
	$la_Row =& $lo_Query->nextrow();
	if ( $la_Row["personalinfoid"] )
	    $lo_DB->Execute ( "UPDATE personalinfo SET
		    gender=" . db_full_quote($gender). ",
		    firstname=" . db_full_quote($firstname) . ",
		    name=" . db_full_quote($name) . ",
		    firma=" . db_full_quote($firma) . ",
		    anschrift=" . db_full_quote($anschrift) . ",
		    plzort=" . db_full_quote($plzort) . ",
		    plz=" . db_full_quote($plz) . ",
		    land=" . db_full_quote($land) . ",
		    telefon=" . db_full_quote($telefon) . ",
		    fax=" . db_full_quote($fax) . ",
		    emailadresse=" . db_full_quote($emailadresse) . ",
		    kundennummer=" . db_full_quote($kundennummer) . ",
		    freifeldname1=" . db_full_quote($freifeldname1) . ",
		    freifeldwert1=" . db_full_quote($freifeldwert1) . ",
		    freifeldname2=" . db_full_quote($freifeldname2) . ",
		    freifeldwert2=" . db_full_quote($freifeldwert2) . ",
		    freifeldname3=" . db_full_quote($freifeldname3) . ",
		    freifeldwert3=" . db_full_quote($freifeldwert3) . ",
		    kundendatenanzeigen=" . $kundendatenanzeigen . "
		    WHERE id=".$la_Row["personalinfoid"] );
	else
	{
	    $lo_DB->Execute ( "INSERT INTO personalinfo (
		    gender,
		    firstname,
		    name,
		    firma,
		    anschrift,
		    plzort,
		    plz,
		    land,
		    telefon,
		    fax,
		    emailadresse,
		    kundennummer,
		    freifeldname1,
		    freifeldwert1,
		    freifeldname2,
		    freifeldwert2,
		    freifeldname3,
		    freifeldwert3,
		    kundendatenanzeigen
		    ) VALUES (
		    " . db_full_quote($gender). ",
		    " . db_full_quote($firstname) . ",
		    " . db_full_quote($name) . ",
		    " . db_full_quote($firma) . ",
		    " . db_full_quote($anschrift) . ",
		    " . db_full_quote($plzort) . ",
		    " . db_full_quote($plz) . ",
		    " . db_full_quote($land) . ",
		    " . db_full_quote($telefon) . ",
		    " . db_full_quote($fax) . ",
		    " . db_full_quote($emailadresse) . ",
		    " . db_full_quote($kundennummer) . ",
		    " . db_full_quote($freifeldname1) . ",
		    " . db_full_quote($freifeldwert1) . ",
		    " . db_full_quote($freifeldname2) . ",
		    " . db_full_quote($freifeldwert2) . ",
		    " . db_full_quote($freifeldname3) . ",
		    " . db_full_quote($freifeldwert3) . ",
		    " . $kundendatenanzeigen . "
		    )" );
			$liID = $lo_DB->getLastID( 'personalinfo', 'id');
	    $lo_DB->Execute ( "UPDATE admin SET personalinfoid=$liID" );
	}
	$lo_DB->unLockTables();
    }
    /* -------------------- end SaveData -------------------- */





    /* -------------------- methods that generate HTML -------------------- */
    function GetStartHTML()
    {
	$ls_Start = $this->ms_FirstTime ? "<center>".ltext("install_email")."<p>" : "";
	return $ls_Start . PersonalInfo::GetStartHTML();
    }

    function GetEndHTML()
    {
	$ls_End = $this->ms_FirstTime ? "</center>" : "";
	return $ls_End . PersonalInfo::GetEndHTML();
    }
    /* -------------------- end methods that generate HTML -------------------- */

}
?>
